/* DBusAccelerator.c generated by valac 0.43.92, the Vala compiler
 * generated from DBusAccelerator.vala, do not modify */

/**/
/*  Copyright (C) 2015 Nicolas Bruguier, Corentin Noël*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include "gala.h"
#include <meta/meta-plugin.h>
#include <meta/screen.h>
#include <meta/display.h>
#include <gobject/gvaluecollector.h>

#define GALA_TYPE_ACCELERATOR (gala_accelerator_get_type ())
typedef struct _GalaAccelerator GalaAccelerator;
#define _g_free0(var) (var = (g_free (var), NULL))

#define GALA_TYPE_DBUS_ACCELERATOR (gala_dbus_accelerator_get_type ())
#define GALA_DBUS_ACCELERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_DBUS_ACCELERATOR, GalaDBusAccelerator))
#define GALA_DBUS_ACCELERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_DBUS_ACCELERATOR, GalaDBusAcceleratorClass))
#define GALA_IS_DBUS_ACCELERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_DBUS_ACCELERATOR))
#define GALA_IS_DBUS_ACCELERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_DBUS_ACCELERATOR))
#define GALA_DBUS_ACCELERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_DBUS_ACCELERATOR, GalaDBusAcceleratorClass))

typedef struct _GalaDBusAccelerator GalaDBusAccelerator;
typedef struct _GalaDBusAcceleratorClass GalaDBusAcceleratorClass;
typedef struct _GalaDBusAcceleratorPrivate GalaDBusAcceleratorPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _gala_dbus_accelerator_unref0(var) ((var == NULL) ? NULL : (var = (gala_dbus_accelerator_unref (var), NULL)))
typedef struct _GalaParamSpecDBusAccelerator GalaParamSpecDBusAccelerator;
enum  {
	GALA_DBUS_ACCELERATOR_ACCELERATOR_ACTIVATED_SIGNAL,
	GALA_DBUS_ACCELERATOR_NUM_SIGNALS
};
static guint gala_dbus_accelerator_signals[GALA_DBUS_ACCELERATOR_NUM_SIGNALS] = {0};

struct _GalaAccelerator {
	gchar* name;
	guint flags;
};

struct _GalaDBusAccelerator {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GalaDBusAcceleratorPrivate * priv;
};

struct _GalaDBusAcceleratorClass {
	GTypeClass parent_class;
	void (*finalize) (GalaDBusAccelerator *self);
};

struct _GalaDBusAcceleratorPrivate {
	GalaWindowManager* wm;
	GHashTable* grabbed_accelerators;
};

struct _GalaParamSpecDBusAccelerator {
	GParamSpec parent_instance;
};

static gint GalaDBusAccelerator_private_offset;
static gpointer gala_dbus_accelerator_parent_class = NULL;
static GalaDBusAccelerator* gala_dbus_accelerator_instance;
static GalaDBusAccelerator* gala_dbus_accelerator_instance = NULL;

GType gala_accelerator_get_type (void) G_GNUC_CONST;
GalaAccelerator* gala_accelerator_dup (const GalaAccelerator* self);
void gala_accelerator_free (GalaAccelerator* self);
void gala_accelerator_copy (const GalaAccelerator* self,
                            GalaAccelerator* dest);
void gala_accelerator_destroy (GalaAccelerator* self);
gpointer gala_dbus_accelerator_ref (gpointer instance);
void gala_dbus_accelerator_unref (gpointer instance);
GParamSpec* gala_param_spec_dbus_accelerator (const gchar* name,
                                              const gchar* nick,
                                              const gchar* blurb,
                                              GType object_type,
                                              GParamFlags flags);
void gala_value_set_dbus_accelerator (GValue* value,
                                      gpointer v_object);
void gala_value_take_dbus_accelerator (GValue* value,
                                       gpointer v_object);
gpointer gala_value_get_dbus_accelerator (const GValue* value);
GType gala_dbus_accelerator_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaDBusAccelerator, gala_dbus_accelerator_unref)
guint gala_dbus_accelerator_register_object (void* object,
                                             GDBusConnection* connection,
                                             const gchar* path,
                                             GError** error);
GalaDBusAccelerator* gala_dbus_accelerator_init (GalaWindowManager* wm);
static GalaDBusAccelerator* gala_dbus_accelerator_new (GalaWindowManager* _wm);
static GalaDBusAccelerator* gala_dbus_accelerator_construct (GType object_type,
                                                      GalaWindowManager* _wm);
static void _g_free0_ (gpointer var);
static void gala_dbus_accelerator_on_accelerator_activated (GalaDBusAccelerator* self,
                                                     guint action,
                                                     guint device_id,
                                                     guint timestamp);
static void _gala_dbus_accelerator_on_accelerator_activated_meta_display_accelerator_activated (MetaDisplay* _sender,
                                                                                         guint object,
                                                                                         guint p0,
                                                                                         guint p1,
                                                                                         gpointer self);
static gboolean _uint_equal (const guint * s1,
                      const guint * s2);
static void _g_variant_unref0_ (gpointer var);
guint gala_dbus_accelerator_grab_accelerator (GalaDBusAccelerator* self,
                                              const gchar* accelerator,
                                              guint flags,
                                              GError** error);
static guint* _uint_dup (guint* self);
guint* gala_dbus_accelerator_grab_accelerators (GalaDBusAccelerator* self,
                                                GalaAccelerator* accelerators,
                                                gint accelerators_length1,
                                                gint* result_length1,
                                                GError** error);
static void _vala_array_add1 (guint* * array,
                       int* length,
                       int* size,
                       guint value);
gboolean gala_dbus_accelerator_ungrab_accelerator (GalaDBusAccelerator* self,
                                                   guint action,
                                                   GError** error);
void gala_dbus_accelerator_show_osd (GalaDBusAccelerator* self,
                                     GHashTable* parameters,
                                     GError** error);
void gala_media_feedback_send (const gchar* icon,
                               gint val);
static void g_cclosure_user_marshal_VOID__UINT_BOXED (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data);
static void gala_dbus_accelerator_finalize (GalaDBusAccelerator * obj);
static void _dbus_gala_dbus_accelerator_grab_accelerator (GalaDBusAccelerator* self,
                                                   GVariant* _parameters_,
                                                   GDBusMethodInvocation* invocation);
static void _vala_GalaAccelerator_array_free (GalaAccelerator * array,
                                       gint array_length);
static void _dbus_gala_dbus_accelerator_grab_accelerators (GalaDBusAccelerator* self,
                                                    GVariant* _parameters_,
                                                    GDBusMethodInvocation* invocation);
static void _dbus_gala_dbus_accelerator_ungrab_accelerator (GalaDBusAccelerator* self,
                                                     GVariant* _parameters_,
                                                     GDBusMethodInvocation* invocation);
static void _dbus_gala_dbus_accelerator_show_osd (GalaDBusAccelerator* self,
                                           GVariant* _parameters_,
                                           GDBusMethodInvocation* invocation);
static void gala_dbus_accelerator_dbus_interface_method_call (GDBusConnection* connection,
                                                       const gchar* sender,
                                                       const gchar* object_path,
                                                       const gchar* interface_name,
                                                       const gchar* method_name,
                                                       GVariant* parameters,
                                                       GDBusMethodInvocation* invocation,
                                                       gpointer user_data);
static GVariant* gala_dbus_accelerator_dbus_interface_get_property (GDBusConnection* connection,
                                                             const gchar* sender,
                                                             const gchar* object_path,
                                                             const gchar* interface_name,
                                                             const gchar* property_name,
                                                             GError** error,
                                                             gpointer user_data);
static gboolean gala_dbus_accelerator_dbus_interface_set_property (GDBusConnection* connection,
                                                            const gchar* sender,
                                                            const gchar* object_path,
                                                            const gchar* interface_name,
                                                            const gchar* property_name,
                                                            GVariant* value,
                                                            GError** error,
                                                            gpointer user_data);
static void _dbus_gala_dbus_accelerator_accelerator_activated (GObject* _sender,
                                                        guint action,
                                                        GHashTable* parameters,
                                                        gpointer* _data);
static void _gala_dbus_accelerator_unregister_object (gpointer user_data);

static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_grab_accelerator_accelerator = {-1, "accelerator", "s", NULL};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_grab_accelerator_flags = {-1, "flags", "u", NULL};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_grab_accelerator_result = {-1, "result", "u", NULL};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_grab_accelerator_in[] = {&_gala_dbus_accelerator_dbus_arg_info_grab_accelerator_accelerator, &_gala_dbus_accelerator_dbus_arg_info_grab_accelerator_flags, NULL};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_grab_accelerator_out[] = {&_gala_dbus_accelerator_dbus_arg_info_grab_accelerator_result, NULL};
static const GDBusMethodInfo _gala_dbus_accelerator_dbus_method_info_grab_accelerator = {-1, "GrabAccelerator", (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_grab_accelerator_in), (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_grab_accelerator_out), NULL};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_grab_accelerators_accelerators = {-1, "accelerators", "a(su)", NULL};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_grab_accelerators_result = {-1, "result", "au", NULL};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_grab_accelerators_in[] = {&_gala_dbus_accelerator_dbus_arg_info_grab_accelerators_accelerators, NULL};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_grab_accelerators_out[] = {&_gala_dbus_accelerator_dbus_arg_info_grab_accelerators_result, NULL};
static const GDBusMethodInfo _gala_dbus_accelerator_dbus_method_info_grab_accelerators = {-1, "GrabAccelerators", (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_grab_accelerators_in), (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_grab_accelerators_out), NULL};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_action = {-1, "action", "u", NULL};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_in[] = {&_gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_action, NULL};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_out[] = {&_gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_result, NULL};
static const GDBusMethodInfo _gala_dbus_accelerator_dbus_method_info_ungrab_accelerator = {-1, "UngrabAccelerator", (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_in), (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_out), NULL};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_show_osd_parameters = {-1, "parameters", "a{sv}", NULL};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_show_osd_in[] = {&_gala_dbus_accelerator_dbus_arg_info_show_osd_parameters, NULL};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_show_osd_out[] = {NULL};
static const GDBusMethodInfo _gala_dbus_accelerator_dbus_method_info_show_osd = {-1, "ShowOSD", (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_show_osd_in), (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_show_osd_out), NULL};
static const GDBusMethodInfo * const _gala_dbus_accelerator_dbus_method_info[] = {&_gala_dbus_accelerator_dbus_method_info_grab_accelerator, &_gala_dbus_accelerator_dbus_method_info_grab_accelerators, &_gala_dbus_accelerator_dbus_method_info_ungrab_accelerator, &_gala_dbus_accelerator_dbus_method_info_show_osd, NULL};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_accelerator_activated_action = {-1, "action", "u", NULL};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_accelerator_activated_parameters = {-1, "parameters", "a{sv}", NULL};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_accelerator_activated[] = {&_gala_dbus_accelerator_dbus_arg_info_accelerator_activated_action, &_gala_dbus_accelerator_dbus_arg_info_accelerator_activated_parameters, NULL};
static const GDBusSignalInfo _gala_dbus_accelerator_dbus_signal_info_accelerator_activated = {-1, "AcceleratorActivated", (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_accelerator_activated), NULL};
static const GDBusSignalInfo * const _gala_dbus_accelerator_dbus_signal_info[] = {&_gala_dbus_accelerator_dbus_signal_info_accelerator_activated, NULL};
static const GDBusPropertyInfo * const _gala_dbus_accelerator_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _gala_dbus_accelerator_dbus_interface_info = {-1, "org.gnome.Shell", (GDBusMethodInfo **) (&_gala_dbus_accelerator_dbus_method_info), (GDBusSignalInfo **) (&_gala_dbus_accelerator_dbus_signal_info), (GDBusPropertyInfo **) (&_gala_dbus_accelerator_dbus_property_info), NULL};
static const GDBusInterfaceVTable _gala_dbus_accelerator_dbus_interface_vtable = {gala_dbus_accelerator_dbus_interface_method_call, gala_dbus_accelerator_dbus_interface_get_property, gala_dbus_accelerator_dbus_interface_set_property};

void
gala_accelerator_copy (const GalaAccelerator* self,
                       GalaAccelerator* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 20 "../src/DBusAccelerator.vala"
	_tmp0_ = (*self).name;
#line 20 "../src/DBusAccelerator.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 20 "../src/DBusAccelerator.vala"
	_g_free0 ((*dest).name);
#line 20 "../src/DBusAccelerator.vala"
	(*dest).name = _tmp1_;
#line 20 "../src/DBusAccelerator.vala"
	(*dest).flags = (*self).flags;
#line 246 "DBusAccelerator.c"
}

void
gala_accelerator_destroy (GalaAccelerator* self)
{
#line 22 "../src/DBusAccelerator.vala"
	_g_free0 ((*self).name);
#line 254 "DBusAccelerator.c"
}

GalaAccelerator*
gala_accelerator_dup (const GalaAccelerator* self)
{
	GalaAccelerator* dup;
#line 20 "../src/DBusAccelerator.vala"
	dup = g_new0 (GalaAccelerator, 1);
#line 20 "../src/DBusAccelerator.vala"
	gala_accelerator_copy (self, dup);
#line 20 "../src/DBusAccelerator.vala"
	return dup;
#line 267 "DBusAccelerator.c"
}

void
gala_accelerator_free (GalaAccelerator* self)
{
#line 20 "../src/DBusAccelerator.vala"
	gala_accelerator_destroy (self);
#line 20 "../src/DBusAccelerator.vala"
	g_free (self);
#line 277 "DBusAccelerator.c"
}

GType
gala_accelerator_get_type (void)
{
	static volatile gsize gala_accelerator_type_id__volatile = 0;
	if (g_once_init_enter (&gala_accelerator_type_id__volatile)) {
		GType gala_accelerator_type_id;
		gala_accelerator_type_id = g_boxed_type_register_static ("GalaAccelerator", (GBoxedCopyFunc) gala_accelerator_dup, (GBoxedFreeFunc) gala_accelerator_free);
		g_once_init_leave (&gala_accelerator_type_id__volatile, gala_accelerator_type_id);
	}
	return gala_accelerator_type_id__volatile;
}

static inline gpointer
gala_dbus_accelerator_get_instance_private (GalaDBusAccelerator* self)
{
	return G_STRUCT_MEMBER_P (self, GalaDBusAccelerator_private_offset);
}

GalaDBusAccelerator*
gala_dbus_accelerator_init (GalaWindowManager* wm)
{
	GalaDBusAccelerator* result = NULL;
	GalaDBusAccelerator* _tmp0_;
	GalaDBusAccelerator* _tmp2_;
#line 32 "../src/DBusAccelerator.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 34 "../src/DBusAccelerator.vala"
	_tmp0_ = gala_dbus_accelerator_instance;
#line 34 "../src/DBusAccelerator.vala"
	if (_tmp0_ == NULL) {
#line 310 "DBusAccelerator.c"
		GalaDBusAccelerator* _tmp1_;
#line 35 "../src/DBusAccelerator.vala"
		_tmp1_ = gala_dbus_accelerator_new (wm);
#line 35 "../src/DBusAccelerator.vala"
		_gala_dbus_accelerator_unref0 (gala_dbus_accelerator_instance);
#line 35 "../src/DBusAccelerator.vala"
		gala_dbus_accelerator_instance = _tmp1_;
#line 318 "DBusAccelerator.c"
	}
#line 37 "../src/DBusAccelerator.vala"
	_tmp2_ = gala_dbus_accelerator_instance;
#line 37 "../src/DBusAccelerator.vala"
	result = _tmp2_;
#line 37 "../src/DBusAccelerator.vala"
	return result;
#line 326 "DBusAccelerator.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 47 "../src/DBusAccelerator.vala"
	return self ? g_object_ref (self) : NULL;
#line 334 "DBusAccelerator.c"
}

static void
_g_free0_ (gpointer var)
{
#line 48 "../src/DBusAccelerator.vala"
	var = (g_free (var), NULL);
#line 342 "DBusAccelerator.c"
}

static void
_gala_dbus_accelerator_on_accelerator_activated_meta_display_accelerator_activated (MetaDisplay* _sender,
                                                                                    guint object,
                                                                                    guint p0,
                                                                                    guint p1,
                                                                                    gpointer self)
{
#line 50 "../src/DBusAccelerator.vala"
	gala_dbus_accelerator_on_accelerator_activated ((GalaDBusAccelerator*) self, object, p0, p1);
#line 354 "DBusAccelerator.c"
}

static GalaDBusAccelerator*
gala_dbus_accelerator_construct (GType object_type,
                                 GalaWindowManager* _wm)
{
	GalaDBusAccelerator* self = NULL;
	GalaWindowManager* _tmp0_;
	GHashFunc _tmp1_;
	GEqualFunc _tmp2_;
	GHashTable* _tmp3_;
	GalaWindowManager* _tmp4_;
	MetaScreen* _tmp5_;
	MetaDisplay* _tmp6_;
#line 45 "../src/DBusAccelerator.vala"
	g_return_val_if_fail (_wm != NULL, NULL);
#line 45 "../src/DBusAccelerator.vala"
	self = (GalaDBusAccelerator*) g_type_create_instance (object_type);
#line 47 "../src/DBusAccelerator.vala"
	_tmp0_ = _g_object_ref0 (_wm);
#line 47 "../src/DBusAccelerator.vala"
	_g_object_unref0 (self->priv->wm);
#line 47 "../src/DBusAccelerator.vala"
	self->priv->wm = _tmp0_;
#line 48 "../src/DBusAccelerator.vala"
	_tmp1_ = g_str_hash;
#line 48 "../src/DBusAccelerator.vala"
	_tmp2_ = g_str_equal;
#line 48 "../src/DBusAccelerator.vala"
	_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, _g_free0_, NULL);
#line 48 "../src/DBusAccelerator.vala"
	_g_hash_table_unref0 (self->priv->grabbed_accelerators);
#line 48 "../src/DBusAccelerator.vala"
	self->priv->grabbed_accelerators = _tmp3_;
#line 50 "../src/DBusAccelerator.vala"
	_tmp4_ = self->priv->wm;
#line 50 "../src/DBusAccelerator.vala"
	_tmp5_ = meta_plugin_get_screen ((MetaPlugin*) _tmp4_);
#line 50 "../src/DBusAccelerator.vala"
	_tmp6_ = meta_screen_get_display (_tmp5_);
#line 50 "../src/DBusAccelerator.vala"
	g_signal_connect (_tmp6_, "accelerator-activated", (GCallback) _gala_dbus_accelerator_on_accelerator_activated_meta_display_accelerator_activated, self);
#line 45 "../src/DBusAccelerator.vala"
	return self;
#line 399 "DBusAccelerator.c"
}

static GalaDBusAccelerator*
gala_dbus_accelerator_new (GalaWindowManager* _wm)
{
#line 45 "../src/DBusAccelerator.vala"
	return gala_dbus_accelerator_construct (GALA_TYPE_DBUS_ACCELERATOR, _wm);
#line 407 "DBusAccelerator.c"
}

static gboolean
_uint_equal (const guint * s1,
             const guint * s2)
{
#line 56 "../src/DBusAccelerator.vala"
	if (s1 == s2) {
#line 56 "../src/DBusAccelerator.vala"
		return TRUE;
#line 418 "DBusAccelerator.c"
	}
#line 56 "../src/DBusAccelerator.vala"
	if (s1 == NULL) {
#line 56 "../src/DBusAccelerator.vala"
		return FALSE;
#line 424 "DBusAccelerator.c"
	}
#line 56 "../src/DBusAccelerator.vala"
	if (s2 == NULL) {
#line 56 "../src/DBusAccelerator.vala"
		return FALSE;
#line 430 "DBusAccelerator.c"
	}
#line 56 "../src/DBusAccelerator.vala"
	return (*s1) == (*s2);
#line 434 "DBusAccelerator.c"
}

static void
_g_variant_unref0_ (gpointer var)
{
#line 57 "../src/DBusAccelerator.vala"
	(var == NULL) ? NULL : (var = (g_variant_unref (var), NULL));
#line 442 "DBusAccelerator.c"
}

static void
gala_dbus_accelerator_on_accelerator_activated (GalaDBusAccelerator* self,
                                                guint action,
                                                guint device_id,
                                                guint timestamp)
{
	GHashTable* _tmp0_;
	GList* _tmp1_;
#line 53 "../src/DBusAccelerator.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/DBusAccelerator.vala"
	_tmp0_ = self->priv->grabbed_accelerators;
#line 55 "../src/DBusAccelerator.vala"
	_tmp1_ = g_hash_table_get_keys (_tmp0_);
#line 459 "DBusAccelerator.c"
	{
		GList* accelerator_collection = NULL;
		GList* accelerator_it = NULL;
#line 55 "../src/DBusAccelerator.vala"
		accelerator_collection = _tmp1_;
#line 55 "../src/DBusAccelerator.vala"
		for (accelerator_it = accelerator_collection; accelerator_it != NULL; accelerator_it = accelerator_it->next) {
#line 467 "DBusAccelerator.c"
			gchar* _tmp2_;
			gchar* accelerator = NULL;
#line 55 "../src/DBusAccelerator.vala"
			_tmp2_ = g_strdup ((const gchar*) accelerator_it->data);
#line 55 "../src/DBusAccelerator.vala"
			accelerator = _tmp2_;
#line 474 "DBusAccelerator.c"
			{
				GHashTable* _tmp3_;
				const gchar* _tmp4_;
				gconstpointer _tmp5_;
#line 56 "../src/DBusAccelerator.vala"
				_tmp3_ = self->priv->grabbed_accelerators;
#line 56 "../src/DBusAccelerator.vala"
				_tmp4_ = accelerator;
#line 56 "../src/DBusAccelerator.vala"
				_tmp5_ = g_hash_table_lookup (_tmp3_, _tmp4_);
#line 56 "../src/DBusAccelerator.vala"
				if (_uint_equal ((guint*) _tmp5_, &action) == TRUE) {
#line 487 "DBusAccelerator.c"
					GHashTable* parameters = NULL;
					GHashTable* _tmp6_;
					GHashTable* _tmp7_;
					gchar* _tmp8_;
					GVariant* _tmp9_;
					GHashTable* _tmp10_;
					gchar* _tmp11_;
					GVariant* _tmp12_;
					GHashTable* _tmp13_;
#line 57 "../src/DBusAccelerator.vala"
					_tmp6_ = g_hash_table_new_full (NULL, NULL, _g_free0_, _g_variant_unref0_);
#line 57 "../src/DBusAccelerator.vala"
					parameters = _tmp6_;
#line 58 "../src/DBusAccelerator.vala"
					_tmp7_ = parameters;
#line 58 "../src/DBusAccelerator.vala"
					_tmp8_ = g_strdup ("device-id");
#line 58 "../src/DBusAccelerator.vala"
					_tmp9_ = g_variant_new_uint32 ((guint32) device_id);
#line 58 "../src/DBusAccelerator.vala"
					g_variant_ref_sink (_tmp9_);
#line 58 "../src/DBusAccelerator.vala"
					g_hash_table_insert (_tmp7_, _tmp8_, _tmp9_);
#line 59 "../src/DBusAccelerator.vala"
					_tmp10_ = parameters;
#line 59 "../src/DBusAccelerator.vala"
					_tmp11_ = g_strdup ("timestamp");
#line 59 "../src/DBusAccelerator.vala"
					_tmp12_ = g_variant_new_uint32 ((guint32) timestamp);
#line 59 "../src/DBusAccelerator.vala"
					g_variant_ref_sink (_tmp12_);
#line 59 "../src/DBusAccelerator.vala"
					g_hash_table_insert (_tmp10_, _tmp11_, _tmp12_);
#line 61 "../src/DBusAccelerator.vala"
					_tmp13_ = parameters;
#line 61 "../src/DBusAccelerator.vala"
					g_signal_emit (self, gala_dbus_accelerator_signals[GALA_DBUS_ACCELERATOR_ACCELERATOR_ACTIVATED_SIGNAL], 0, action, _tmp13_);
#line 56 "../src/DBusAccelerator.vala"
					_g_hash_table_unref0 (parameters);
#line 527 "DBusAccelerator.c"
				}
#line 55 "../src/DBusAccelerator.vala"
				_g_free0 (accelerator);
#line 531 "DBusAccelerator.c"
			}
		}
#line 55 "../src/DBusAccelerator.vala"
		(accelerator_collection == NULL) ? NULL : (accelerator_collection = (g_list_free (accelerator_collection), NULL));
#line 536 "DBusAccelerator.c"
	}
}

static guint*
_uint_dup (guint* self)
{
	guint* dup;
#line 68 "../src/DBusAccelerator.vala"
	dup = g_new0 (guint, 1);
#line 68 "../src/DBusAccelerator.vala"
	memcpy (dup, self, sizeof (guint));
#line 68 "../src/DBusAccelerator.vala"
	return dup;
#line 550 "DBusAccelerator.c"
}

static gpointer
__uint_dup0 (gpointer self)
{
#line 68 "../src/DBusAccelerator.vala"
	return self ? _uint_dup (self) : NULL;
#line 558 "DBusAccelerator.c"
}

guint
gala_dbus_accelerator_grab_accelerator (GalaDBusAccelerator* self,
                                        const gchar* accelerator,
                                        guint flags,
                                        GError** error)
{
	guint result = 0U;
	guint* action = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	guint* _tmp2_;
	guint* _tmp3_;
	guint* _tmp14_;
	guint _tmp15_;
#line 66 "../src/DBusAccelerator.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 66 "../src/DBusAccelerator.vala"
	g_return_val_if_fail (accelerator != NULL, 0U);
#line 68 "../src/DBusAccelerator.vala"
	_tmp0_ = self->priv->grabbed_accelerators;
#line 68 "../src/DBusAccelerator.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, accelerator);
#line 68 "../src/DBusAccelerator.vala"
	_tmp2_ = __uint_dup0 ((guint*) _tmp1_);
#line 68 "../src/DBusAccelerator.vala"
	action = _tmp2_;
#line 70 "../src/DBusAccelerator.vala"
	_tmp3_ = action;
#line 70 "../src/DBusAccelerator.vala"
	if (_tmp3_ == NULL) {
#line 591 "DBusAccelerator.c"
		GalaWindowManager* _tmp4_;
		MetaScreen* _tmp5_;
		MetaDisplay* _tmp6_;
		guint _tmp7_;
		guint* _tmp8_;
		guint* _tmp9_;
#line 71 "../src/DBusAccelerator.vala"
		_tmp4_ = self->priv->wm;
#line 71 "../src/DBusAccelerator.vala"
		_tmp5_ = meta_plugin_get_screen ((MetaPlugin*) _tmp4_);
#line 71 "../src/DBusAccelerator.vala"
		_tmp6_ = meta_screen_get_display (_tmp5_);
#line 71 "../src/DBusAccelerator.vala"
		_tmp7_ = meta_display_grab_accelerator (_tmp6_, accelerator);
#line 71 "../src/DBusAccelerator.vala"
		_tmp8_ = __uint_dup0 (&_tmp7_);
#line 71 "../src/DBusAccelerator.vala"
		_g_free0 (action);
#line 71 "../src/DBusAccelerator.vala"
		action = _tmp8_;
#line 72 "../src/DBusAccelerator.vala"
		_tmp9_ = action;
#line 72 "../src/DBusAccelerator.vala"
		if ((*_tmp9_) > ((guint) 0)) {
#line 616 "DBusAccelerator.c"
			GHashTable* _tmp10_;
			gchar* _tmp11_;
			guint* _tmp12_;
			guint* _tmp13_;
#line 73 "../src/DBusAccelerator.vala"
			_tmp10_ = self->priv->grabbed_accelerators;
#line 73 "../src/DBusAccelerator.vala"
			_tmp11_ = g_strdup (accelerator);
#line 73 "../src/DBusAccelerator.vala"
			_tmp12_ = action;
#line 73 "../src/DBusAccelerator.vala"
			_tmp13_ = __uint_dup0 (_tmp12_);
#line 73 "../src/DBusAccelerator.vala"
			g_hash_table_insert (_tmp10_, _tmp11_, _tmp13_);
#line 631 "DBusAccelerator.c"
		}
	}
#line 77 "../src/DBusAccelerator.vala"
	_tmp14_ = action;
#line 77 "../src/DBusAccelerator.vala"
	_tmp15_ = *_tmp14_;
#line 77 "../src/DBusAccelerator.vala"
	_g_free0 (_tmp14_);
#line 77 "../src/DBusAccelerator.vala"
	result = _tmp15_;
#line 77 "../src/DBusAccelerator.vala"
	return result;
#line 644 "DBusAccelerator.c"
}

static void
_vala_array_add1 (guint* * array,
                  int* length,
                  int* size,
                  guint value)
{
#line 85 "../src/DBusAccelerator.vala"
	if ((*length) == (*size)) {
#line 85 "../src/DBusAccelerator.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 85 "../src/DBusAccelerator.vala"
		*array = g_renew (guint, *array, *size);
#line 659 "DBusAccelerator.c"
	}
#line 85 "../src/DBusAccelerator.vala"
	(*array)[(*length)++] = value;
#line 663 "DBusAccelerator.c"
}

guint*
gala_dbus_accelerator_grab_accelerators (GalaDBusAccelerator* self,
                                         GalaAccelerator* accelerators,
                                         gint accelerators_length1,
                                         gint* result_length1,
                                         GError** error)
{
	guint* result = NULL;
	guint* actions = NULL;
	guint* _tmp0_;
	gint actions_length1;
	gint _actions_size_;
	guint* _tmp6_;
	gint _tmp6__length1;
	GError* _inner_error0_ = NULL;
#line 80 "../src/DBusAccelerator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 82 "../src/DBusAccelerator.vala"
	_tmp0_ = g_new0 (guint, 0);
#line 82 "../src/DBusAccelerator.vala"
	actions = _tmp0_;
#line 82 "../src/DBusAccelerator.vala"
	actions_length1 = 0;
#line 82 "../src/DBusAccelerator.vala"
	_actions_size_ = actions_length1;
#line 691 "DBusAccelerator.c"
	{
		GalaAccelerator* accelerator_collection = NULL;
		gint accelerator_collection_length1 = 0;
		gint _accelerator_collection_size_ = 0;
		gint accelerator_it = 0;
#line 84 "../src/DBusAccelerator.vala"
		accelerator_collection = accelerators;
#line 84 "../src/DBusAccelerator.vala"
		accelerator_collection_length1 = accelerators_length1;
#line 84 "../src/DBusAccelerator.vala"
		for (accelerator_it = 0; accelerator_it < accelerators_length1; accelerator_it = accelerator_it + 1) {
#line 703 "DBusAccelerator.c"
			GalaAccelerator* accelerator = NULL;
#line 84 "../src/DBusAccelerator.vala"
			accelerator = &accelerator_collection[accelerator_it];
#line 707 "DBusAccelerator.c"
			{
				guint _tmp1_ = 0U;
				GalaAccelerator* _tmp2_;
				const gchar* _tmp3_;
				GalaAccelerator* _tmp4_;
				guint* _tmp5_;
				gint _tmp5__length1;
#line 85 "../src/DBusAccelerator.vala"
				_tmp2_ = accelerator;
#line 85 "../src/DBusAccelerator.vala"
				_tmp3_ = (*_tmp2_).name;
#line 85 "../src/DBusAccelerator.vala"
				_tmp4_ = accelerator;
#line 85 "../src/DBusAccelerator.vala"
				_tmp1_ = gala_dbus_accelerator_grab_accelerator (self, _tmp3_, (*_tmp4_).flags, &_inner_error0_);
#line 85 "../src/DBusAccelerator.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 85 "../src/DBusAccelerator.vala"
					if ((_inner_error0_->domain == G_DBUS_ERROR) || (_inner_error0_->domain == G_IO_ERROR)) {
#line 85 "../src/DBusAccelerator.vala"
						g_propagate_error (error, _inner_error0_);
#line 85 "../src/DBusAccelerator.vala"
						actions = (g_free (actions), NULL);
#line 85 "../src/DBusAccelerator.vala"
						return NULL;
#line 733 "DBusAccelerator.c"
					} else {
#line 85 "../src/DBusAccelerator.vala"
						actions = (g_free (actions), NULL);
#line 85 "../src/DBusAccelerator.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 85 "../src/DBusAccelerator.vala"
						g_clear_error (&_inner_error0_);
#line 85 "../src/DBusAccelerator.vala"
						return NULL;
#line 743 "DBusAccelerator.c"
					}
				}
#line 85 "../src/DBusAccelerator.vala"
				_tmp5_ = actions;
#line 85 "../src/DBusAccelerator.vala"
				_tmp5__length1 = actions_length1;
#line 85 "../src/DBusAccelerator.vala"
				_vala_array_add1 (&actions, &actions_length1, &_actions_size_, _tmp1_);
#line 752 "DBusAccelerator.c"
			}
		}
	}
#line 88 "../src/DBusAccelerator.vala"
	_tmp6_ = actions;
#line 88 "../src/DBusAccelerator.vala"
	_tmp6__length1 = actions_length1;
#line 88 "../src/DBusAccelerator.vala"
	if (result_length1) {
#line 88 "../src/DBusAccelerator.vala"
		*result_length1 = _tmp6__length1;
#line 764 "DBusAccelerator.c"
	}
#line 88 "../src/DBusAccelerator.vala"
	result = _tmp6_;
#line 88 "../src/DBusAccelerator.vala"
	return result;
#line 770 "DBusAccelerator.c"
}

gboolean
gala_dbus_accelerator_ungrab_accelerator (GalaDBusAccelerator* self,
                                          guint action,
                                          GError** error)
{
	gboolean result = FALSE;
	gboolean ret = FALSE;
	GHashTable* _tmp0_;
	GList* _tmp1_;
#line 91 "../src/DBusAccelerator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 93 "../src/DBusAccelerator.vala"
	ret = FALSE;
#line 95 "../src/DBusAccelerator.vala"
	_tmp0_ = self->priv->grabbed_accelerators;
#line 95 "../src/DBusAccelerator.vala"
	_tmp1_ = g_hash_table_get_keys (_tmp0_);
#line 790 "DBusAccelerator.c"
	{
		GList* accelerator_collection = NULL;
		GList* accelerator_it = NULL;
#line 95 "../src/DBusAccelerator.vala"
		accelerator_collection = _tmp1_;
#line 95 "../src/DBusAccelerator.vala"
		for (accelerator_it = accelerator_collection; accelerator_it != NULL; accelerator_it = accelerator_it->next) {
#line 798 "DBusAccelerator.c"
			const gchar* accelerator = NULL;
#line 95 "../src/DBusAccelerator.vala"
			accelerator = (const gchar*) accelerator_it->data;
#line 802 "DBusAccelerator.c"
			{
				GHashTable* _tmp2_;
				const gchar* _tmp3_;
				gconstpointer _tmp4_;
#line 96 "../src/DBusAccelerator.vala"
				_tmp2_ = self->priv->grabbed_accelerators;
#line 96 "../src/DBusAccelerator.vala"
				_tmp3_ = accelerator;
#line 96 "../src/DBusAccelerator.vala"
				_tmp4_ = g_hash_table_lookup (_tmp2_, _tmp3_);
#line 96 "../src/DBusAccelerator.vala"
				if (_uint_equal ((guint*) _tmp4_, &action) == TRUE) {
#line 815 "DBusAccelerator.c"
					GalaWindowManager* _tmp5_;
					MetaScreen* _tmp6_;
					MetaDisplay* _tmp7_;
					GHashTable* _tmp8_;
					const gchar* _tmp9_;
#line 97 "../src/DBusAccelerator.vala"
					_tmp5_ = self->priv->wm;
#line 97 "../src/DBusAccelerator.vala"
					_tmp6_ = meta_plugin_get_screen ((MetaPlugin*) _tmp5_);
#line 97 "../src/DBusAccelerator.vala"
					_tmp7_ = meta_screen_get_display (_tmp6_);
#line 97 "../src/DBusAccelerator.vala"
					ret = meta_display_ungrab_accelerator (_tmp7_, action);
#line 98 "../src/DBusAccelerator.vala"
					_tmp8_ = self->priv->grabbed_accelerators;
#line 98 "../src/DBusAccelerator.vala"
					_tmp9_ = accelerator;
#line 98 "../src/DBusAccelerator.vala"
					g_hash_table_remove (_tmp8_, _tmp9_);
#line 99 "../src/DBusAccelerator.vala"
					break;
#line 837 "DBusAccelerator.c"
				}
			}
		}
#line 95 "../src/DBusAccelerator.vala"
		(accelerator_collection == NULL) ? NULL : (accelerator_collection = (g_list_free (accelerator_collection), NULL));
#line 843 "DBusAccelerator.c"
	}
#line 103 "../src/DBusAccelerator.vala"
	result = ret;
#line 103 "../src/DBusAccelerator.vala"
	return result;
#line 849 "DBusAccelerator.c"
}

void
gala_dbus_accelerator_show_osd (GalaDBusAccelerator* self,
                                GHashTable* parameters,
                                GError** error)
{
	gint32 monitor_index = 0;
	gchar* icon = NULL;
	gchar* _tmp1_;
	gchar* label = NULL;
	gchar* _tmp5_;
	gint32 level = 0;
	const gchar* _tmp10_;
#line 107 "../src/DBusAccelerator.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/DBusAccelerator.vala"
	g_return_if_fail (parameters != NULL);
#line 109 "../src/DBusAccelerator.vala"
	monitor_index = (gint32) -1;
#line 110 "../src/DBusAccelerator.vala"
	if (g_hash_table_contains (parameters, "monitor")) {
#line 872 "DBusAccelerator.c"
		gconstpointer _tmp0_;
#line 111 "../src/DBusAccelerator.vala"
		_tmp0_ = g_hash_table_lookup (parameters, "monitor");
#line 111 "../src/DBusAccelerator.vala"
		monitor_index = g_variant_get_int32 ((GVariant*) _tmp0_);
#line 878 "DBusAccelerator.c"
	}
#line 112 "../src/DBusAccelerator.vala"
	_tmp1_ = g_strdup ("");
#line 112 "../src/DBusAccelerator.vala"
	icon = _tmp1_;
#line 113 "../src/DBusAccelerator.vala"
	if (g_hash_table_contains (parameters, "icon")) {
#line 886 "DBusAccelerator.c"
		gconstpointer _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 114 "../src/DBusAccelerator.vala"
		_tmp2_ = g_hash_table_lookup (parameters, "icon");
#line 114 "../src/DBusAccelerator.vala"
		_tmp3_ = g_variant_get_string ((GVariant*) _tmp2_, NULL);
#line 114 "../src/DBusAccelerator.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 114 "../src/DBusAccelerator.vala"
		_g_free0 (icon);
#line 114 "../src/DBusAccelerator.vala"
		icon = _tmp4_;
#line 900 "DBusAccelerator.c"
	}
#line 115 "../src/DBusAccelerator.vala"
	_tmp5_ = g_strdup ("");
#line 115 "../src/DBusAccelerator.vala"
	label = _tmp5_;
#line 116 "../src/DBusAccelerator.vala"
	if (g_hash_table_contains (parameters, "label")) {
#line 908 "DBusAccelerator.c"
		gconstpointer _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 117 "../src/DBusAccelerator.vala"
		_tmp6_ = g_hash_table_lookup (parameters, "label");
#line 117 "../src/DBusAccelerator.vala"
		_tmp7_ = g_variant_get_string ((GVariant*) _tmp6_, NULL);
#line 117 "../src/DBusAccelerator.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 117 "../src/DBusAccelerator.vala"
		_g_free0 (label);
#line 117 "../src/DBusAccelerator.vala"
		label = _tmp8_;
#line 922 "DBusAccelerator.c"
	}
#line 118 "../src/DBusAccelerator.vala"
	level = (gint32) 0;
#line 119 "../src/DBusAccelerator.vala"
	if (g_hash_table_contains (parameters, "level")) {
#line 928 "DBusAccelerator.c"
		gconstpointer _tmp9_;
#line 120 "../src/DBusAccelerator.vala"
		_tmp9_ = g_hash_table_lookup (parameters, "level");
#line 120 "../src/DBusAccelerator.vala"
		level = g_variant_get_int32 ((GVariant*) _tmp9_);
#line 934 "DBusAccelerator.c"
	}
#line 125 "../src/DBusAccelerator.vala"
	_tmp10_ = icon;
#line 125 "../src/DBusAccelerator.vala"
	gala_media_feedback_send (_tmp10_, (gint) level);
#line 107 "../src/DBusAccelerator.vala"
	_g_free0 (label);
#line 107 "../src/DBusAccelerator.vala"
	_g_free0 (icon);
#line 944 "DBusAccelerator.c"
}

static void
g_cclosure_user_marshal_VOID__UINT_BOXED (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UINT_BOXED) (gpointer data1, guint arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT_BOXED callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 27 "../src/DBusAccelerator.vala"
	g_return_if_fail (n_param_values == 3);
#line 27 "../src/DBusAccelerator.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 27 "../src/DBusAccelerator.vala"
		data1 = closure->data;
#line 27 "../src/DBusAccelerator.vala"
		data2 = param_values->data[0].v_pointer;
#line 969 "DBusAccelerator.c"
	} else {
#line 27 "../src/DBusAccelerator.vala"
		data1 = param_values->data[0].v_pointer;
#line 27 "../src/DBusAccelerator.vala"
		data2 = closure->data;
#line 975 "DBusAccelerator.c"
	}
#line 27 "../src/DBusAccelerator.vala"
	callback = (GMarshalFunc_VOID__UINT_BOXED) (marshal_data ? marshal_data : cc->callback);
#line 27 "../src/DBusAccelerator.vala"
	callback (data1, g_value_get_uint (param_values + 1), g_value_get_boxed (param_values + 2), data2);
#line 981 "DBusAccelerator.c"
}

static void
gala_value_dbus_accelerator_init (GValue* value)
{
#line 27 "../src/DBusAccelerator.vala"
	value->data[0].v_pointer = NULL;
#line 989 "DBusAccelerator.c"
}

static void
gala_value_dbus_accelerator_free_value (GValue* value)
{
#line 27 "../src/DBusAccelerator.vala"
	if (value->data[0].v_pointer) {
#line 27 "../src/DBusAccelerator.vala"
		gala_dbus_accelerator_unref (value->data[0].v_pointer);
#line 999 "DBusAccelerator.c"
	}
}

static void
gala_value_dbus_accelerator_copy_value (const GValue* src_value,
                                        GValue* dest_value)
{
#line 27 "../src/DBusAccelerator.vala"
	if (src_value->data[0].v_pointer) {
#line 27 "../src/DBusAccelerator.vala"
		dest_value->data[0].v_pointer = gala_dbus_accelerator_ref (src_value->data[0].v_pointer);
#line 1011 "DBusAccelerator.c"
	} else {
#line 27 "../src/DBusAccelerator.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1015 "DBusAccelerator.c"
	}
}

static gpointer
gala_value_dbus_accelerator_peek_pointer (const GValue* value)
{
#line 27 "../src/DBusAccelerator.vala"
	return value->data[0].v_pointer;
#line 1024 "DBusAccelerator.c"
}

static gchar*
gala_value_dbus_accelerator_collect_value (GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
#line 27 "../src/DBusAccelerator.vala"
	if (collect_values[0].v_pointer) {
#line 1035 "DBusAccelerator.c"
		GalaDBusAccelerator * object;
		object = collect_values[0].v_pointer;
#line 27 "../src/DBusAccelerator.vala"
		if (object->parent_instance.g_class == NULL) {
#line 27 "../src/DBusAccelerator.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1042 "DBusAccelerator.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 27 "../src/DBusAccelerator.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1046 "DBusAccelerator.c"
		}
#line 27 "../src/DBusAccelerator.vala"
		value->data[0].v_pointer = gala_dbus_accelerator_ref (object);
#line 1050 "DBusAccelerator.c"
	} else {
#line 27 "../src/DBusAccelerator.vala"
		value->data[0].v_pointer = NULL;
#line 1054 "DBusAccelerator.c"
	}
#line 27 "../src/DBusAccelerator.vala"
	return NULL;
#line 1058 "DBusAccelerator.c"
}

static gchar*
gala_value_dbus_accelerator_lcopy_value (const GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
	GalaDBusAccelerator ** object_p;
	object_p = collect_values[0].v_pointer;
#line 27 "../src/DBusAccelerator.vala"
	if (!object_p) {
#line 27 "../src/DBusAccelerator.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1073 "DBusAccelerator.c"
	}
#line 27 "../src/DBusAccelerator.vala"
	if (!value->data[0].v_pointer) {
#line 27 "../src/DBusAccelerator.vala"
		*object_p = NULL;
#line 1079 "DBusAccelerator.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 27 "../src/DBusAccelerator.vala"
		*object_p = value->data[0].v_pointer;
#line 1083 "DBusAccelerator.c"
	} else {
#line 27 "../src/DBusAccelerator.vala"
		*object_p = gala_dbus_accelerator_ref (value->data[0].v_pointer);
#line 1087 "DBusAccelerator.c"
	}
#line 27 "../src/DBusAccelerator.vala"
	return NULL;
#line 1091 "DBusAccelerator.c"
}

GParamSpec*
gala_param_spec_dbus_accelerator (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags)
{
	GalaParamSpecDBusAccelerator* spec;
#line 27 "../src/DBusAccelerator.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GALA_TYPE_DBUS_ACCELERATOR), NULL);
#line 27 "../src/DBusAccelerator.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 27 "../src/DBusAccelerator.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 27 "../src/DBusAccelerator.vala"
	return G_PARAM_SPEC (spec);
#line 1110 "DBusAccelerator.c"
}

gpointer
gala_value_get_dbus_accelerator (const GValue* value)
{
#line 27 "../src/DBusAccelerator.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_TYPE_DBUS_ACCELERATOR), NULL);
#line 27 "../src/DBusAccelerator.vala"
	return value->data[0].v_pointer;
#line 1120 "DBusAccelerator.c"
}

void
gala_value_set_dbus_accelerator (GValue* value,
                                 gpointer v_object)
{
	GalaDBusAccelerator * old;
#line 27 "../src/DBusAccelerator.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_TYPE_DBUS_ACCELERATOR));
#line 27 "../src/DBusAccelerator.vala"
	old = value->data[0].v_pointer;
#line 27 "../src/DBusAccelerator.vala"
	if (v_object) {
#line 27 "../src/DBusAccelerator.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GALA_TYPE_DBUS_ACCELERATOR));
#line 27 "../src/DBusAccelerator.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 27 "../src/DBusAccelerator.vala"
		value->data[0].v_pointer = v_object;
#line 27 "../src/DBusAccelerator.vala"
		gala_dbus_accelerator_ref (value->data[0].v_pointer);
#line 1142 "DBusAccelerator.c"
	} else {
#line 27 "../src/DBusAccelerator.vala"
		value->data[0].v_pointer = NULL;
#line 1146 "DBusAccelerator.c"
	}
#line 27 "../src/DBusAccelerator.vala"
	if (old) {
#line 27 "../src/DBusAccelerator.vala"
		gala_dbus_accelerator_unref (old);
#line 1152 "DBusAccelerator.c"
	}
}

void
gala_value_take_dbus_accelerator (GValue* value,
                                  gpointer v_object)
{
	GalaDBusAccelerator * old;
#line 27 "../src/DBusAccelerator.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_TYPE_DBUS_ACCELERATOR));
#line 27 "../src/DBusAccelerator.vala"
	old = value->data[0].v_pointer;
#line 27 "../src/DBusAccelerator.vala"
	if (v_object) {
#line 27 "../src/DBusAccelerator.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GALA_TYPE_DBUS_ACCELERATOR));
#line 27 "../src/DBusAccelerator.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 27 "../src/DBusAccelerator.vala"
		value->data[0].v_pointer = v_object;
#line 1173 "DBusAccelerator.c"
	} else {
#line 27 "../src/DBusAccelerator.vala"
		value->data[0].v_pointer = NULL;
#line 1177 "DBusAccelerator.c"
	}
#line 27 "../src/DBusAccelerator.vala"
	if (old) {
#line 27 "../src/DBusAccelerator.vala"
		gala_dbus_accelerator_unref (old);
#line 1183 "DBusAccelerator.c"
	}
}

static void
gala_dbus_accelerator_class_init (GalaDBusAcceleratorClass * klass,
                                  gpointer klass_data)
{
#line 27 "../src/DBusAccelerator.vala"
	gala_dbus_accelerator_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/DBusAccelerator.vala"
	((GalaDBusAcceleratorClass *) klass)->finalize = gala_dbus_accelerator_finalize;
#line 27 "../src/DBusAccelerator.vala"
	g_type_class_adjust_private_offset (klass, &GalaDBusAccelerator_private_offset);
#line 27 "../src/DBusAccelerator.vala"
	gala_dbus_accelerator_signals[GALA_DBUS_ACCELERATOR_ACCELERATOR_ACTIVATED_SIGNAL] = g_signal_new ("accelerator-activated", GALA_TYPE_DBUS_ACCELERATOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT_BOXED, G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_HASH_TABLE);
#line 1199 "DBusAccelerator.c"
}

static void
gala_dbus_accelerator_instance_init (GalaDBusAccelerator * self,
                                     gpointer klass)
{
#line 27 "../src/DBusAccelerator.vala"
	self->priv = gala_dbus_accelerator_get_instance_private (self);
#line 27 "../src/DBusAccelerator.vala"
	self->ref_count = 1;
#line 1210 "DBusAccelerator.c"
}

static void
gala_dbus_accelerator_finalize (GalaDBusAccelerator * obj)
{
	GalaDBusAccelerator * self;
#line 27 "../src/DBusAccelerator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_DBUS_ACCELERATOR, GalaDBusAccelerator);
#line 27 "../src/DBusAccelerator.vala"
	g_signal_handlers_destroy (self);
#line 42 "../src/DBusAccelerator.vala"
	_g_object_unref0 (self->priv->wm);
#line 43 "../src/DBusAccelerator.vala"
	_g_hash_table_unref0 (self->priv->grabbed_accelerators);
#line 1225 "DBusAccelerator.c"
}

GType
gala_dbus_accelerator_get_type (void)
{
	static volatile gsize gala_dbus_accelerator_type_id__volatile = 0;
	if (g_once_init_enter (&gala_dbus_accelerator_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { gala_value_dbus_accelerator_init, gala_value_dbus_accelerator_free_value, gala_value_dbus_accelerator_copy_value, gala_value_dbus_accelerator_peek_pointer, "p", gala_value_dbus_accelerator_collect_value, "p", gala_value_dbus_accelerator_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GalaDBusAcceleratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_dbus_accelerator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaDBusAccelerator), 0, (GInstanceInitFunc) gala_dbus_accelerator_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType gala_dbus_accelerator_type_id;
		gala_dbus_accelerator_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GalaDBusAccelerator", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_type_set_qdata (gala_dbus_accelerator_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) gala_dbus_accelerator_register_object);
		GalaDBusAccelerator_private_offset = g_type_add_instance_private (gala_dbus_accelerator_type_id, sizeof (GalaDBusAcceleratorPrivate));
		g_once_init_leave (&gala_dbus_accelerator_type_id__volatile, gala_dbus_accelerator_type_id);
	}
	return gala_dbus_accelerator_type_id__volatile;
}

gpointer
gala_dbus_accelerator_ref (gpointer instance)
{
	GalaDBusAccelerator * self;
	self = instance;
#line 27 "../src/DBusAccelerator.vala"
	g_atomic_int_inc (&self->ref_count);
#line 27 "../src/DBusAccelerator.vala"
	return instance;
#line 1254 "DBusAccelerator.c"
}

void
gala_dbus_accelerator_unref (gpointer instance)
{
	GalaDBusAccelerator * self;
	self = instance;
#line 27 "../src/DBusAccelerator.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 27 "../src/DBusAccelerator.vala"
		GALA_DBUS_ACCELERATOR_GET_CLASS (self)->finalize (self);
#line 27 "../src/DBusAccelerator.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1268 "DBusAccelerator.c"
	}
}

static void
_dbus_gala_dbus_accelerator_grab_accelerator (GalaDBusAccelerator* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* accelerator = NULL;
	GVariant* _tmp7_;
	guint flags = 0U;
	GVariant* _tmp8_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp7_ = g_variant_iter_next_value (&_arguments_iter);
	accelerator = g_variant_dup_string (_tmp7_, NULL);
	g_variant_unref (_tmp7_);
	_tmp8_ = g_variant_iter_next_value (&_arguments_iter);
	flags = g_variant_get_uint32 (_tmp8_);
	g_variant_unref (_tmp8_);
	result = gala_dbus_accelerator_grab_accelerator (self, accelerator, flags, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_uint32 (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (accelerator);
}

static void
_vala_GalaAccelerator_array_free (GalaAccelerator * array,
                                  gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			gala_accelerator_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_dbus_gala_dbus_accelerator_grab_accelerators (GalaDBusAccelerator* self,
                                               GVariant* _parameters_,
                                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GalaAccelerator* accelerators = NULL;
	gint accelerators_length1 = 0;
	GVariant* _tmp9_;
	GalaAccelerator* _tmp10_;
	gint _tmp10__length;
	gint _tmp10__size;
	gint _tmp10__length1;
	GVariantIter _tmp11_;
	GVariant* _tmp12_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint* result;
	gint result_length1 = 0;
	guint* _tmp17_;
	GVariantBuilder _tmp18_;
	gint _tmp19_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp9_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp10_ = g_new (GalaAccelerator, 5);
	_tmp10__length = 0;
	_tmp10__size = 4;
	_tmp10__length1 = 0;
	g_variant_iter_init (&_tmp11_, _tmp9_);
	for (; (_tmp12_ = g_variant_iter_next_value (&_tmp11_)) != NULL; _tmp10__length1++) {
		GalaAccelerator _tmp13_;
		GVariantIter _tmp14_;
		GVariant* _tmp15_;
		GVariant* _tmp16_;
		if (_tmp10__size == _tmp10__length) {
			_tmp10__size = 2 * _tmp10__size;
			_tmp10_ = g_renew (GalaAccelerator, _tmp10_, _tmp10__size + 1);
		}
		g_variant_iter_init (&_tmp14_, _tmp12_);
		_tmp15_ = g_variant_iter_next_value (&_tmp14_);
		_tmp13_.name = g_variant_dup_string (_tmp15_, NULL);
		g_variant_unref (_tmp15_);
		_tmp16_ = g_variant_iter_next_value (&_tmp14_);
		_tmp13_.flags = g_variant_get_uint32 (_tmp16_);
		g_variant_unref (_tmp16_);
		_tmp10_[_tmp10__length++] = _tmp13_;
		g_variant_unref (_tmp12_);
	}
	accelerators_length1 = _tmp10__length1;
	accelerators = _tmp10_;
	g_variant_unref (_tmp9_);
	result = gala_dbus_accelerator_grab_accelerators (self, accelerators, accelerators_length1, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp17_ = result;
	g_variant_builder_init (&_tmp18_, G_VARIANT_TYPE ("au"));
	for (_tmp19_ = 0; _tmp19_ < result_length1; _tmp19_++) {
		g_variant_builder_add_value (&_tmp18_, g_variant_new_uint32 (*_tmp17_));
		_tmp17_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp18_));
	result = (g_free (result), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	accelerators = (_vala_GalaAccelerator_array_free (accelerators, accelerators_length1), NULL);
}

static void
_dbus_gala_dbus_accelerator_ungrab_accelerator (GalaDBusAccelerator* self,
                                                GVariant* _parameters_,
                                                GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint action = 0U;
	GVariant* _tmp20_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp20_ = g_variant_iter_next_value (&_arguments_iter);
	action = g_variant_get_uint32 (_tmp20_);
	g_variant_unref (_tmp20_);
	result = gala_dbus_accelerator_ungrab_accelerator (self, action, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_gala_dbus_accelerator_show_osd (GalaDBusAccelerator* self,
                                      GVariant* _parameters_,
                                      GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GHashTable* parameters = NULL;
	GVariant* _tmp21_;
	GHashTable* _tmp22_;
	GVariantIter _tmp23_;
	GVariant* _tmp24_;
	GVariant* _tmp25_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp21_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp22_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
	g_variant_iter_init (&_tmp23_, _tmp21_);
	while (g_variant_iter_loop (&_tmp23_, "{?*}", &_tmp24_, &_tmp25_)) {
		g_hash_table_insert (_tmp22_, g_variant_dup_string (_tmp24_, NULL), g_variant_get_variant (_tmp25_));
	}
	parameters = _tmp22_;
	g_variant_unref (_tmp21_);
	gala_dbus_accelerator_show_osd (self, parameters, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_hash_table_unref0 (parameters);
}

static void
gala_dbus_accelerator_dbus_interface_method_call (GDBusConnection* connection,
                                                  const gchar* sender,
                                                  const gchar* object_path,
                                                  const gchar* interface_name,
                                                  const gchar* method_name,
                                                  GVariant* parameters,
                                                  GDBusMethodInvocation* invocation,
                                                  gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "GrabAccelerator") == 0) {
		_dbus_gala_dbus_accelerator_grab_accelerator (object, parameters, invocation);
	} else if (strcmp (method_name, "GrabAccelerators") == 0) {
		_dbus_gala_dbus_accelerator_grab_accelerators (object, parameters, invocation);
	} else if (strcmp (method_name, "UngrabAccelerator") == 0) {
		_dbus_gala_dbus_accelerator_ungrab_accelerator (object, parameters, invocation);
	} else if (strcmp (method_name, "ShowOSD") == 0) {
		_dbus_gala_dbus_accelerator_show_osd (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
gala_dbus_accelerator_dbus_interface_get_property (GDBusConnection* connection,
                                                   const gchar* sender,
                                                   const gchar* object_path,
                                                   const gchar* interface_name,
                                                   const gchar* property_name,
                                                   GError** error,
                                                   gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
gala_dbus_accelerator_dbus_interface_set_property (GDBusConnection* connection,
                                                   const gchar* sender,
                                                   const gchar* object_path,
                                                   const gchar* interface_name,
                                                   const gchar* property_name,
                                                   GVariant* value,
                                                   GError** error,
                                                   gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_gala_dbus_accelerator_accelerator_activated (GObject* _sender,
                                                   guint action,
                                                   GHashTable* parameters,
                                                   gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp26_;
	GHashTableIter _tmp27_;
	gpointer _tmp28_;
	gpointer _tmp29_;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (action));
	g_hash_table_iter_init (&_tmp27_, parameters);
	g_variant_builder_init (&_tmp26_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp27_, &_tmp28_, &_tmp29_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp28_;
		_value = (GVariant*) _tmp29_;
		g_variant_builder_add (&_tmp26_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp26_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.Shell", "AcceleratorActivated", _arguments, NULL);
}

guint
gala_dbus_accelerator_register_object (gpointer object,
                                       GDBusConnection* connection,
                                       const gchar* path,
                                       GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = gala_dbus_accelerator_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_gala_dbus_accelerator_dbus_interface_info), &_gala_dbus_accelerator_dbus_interface_vtable, data, _gala_dbus_accelerator_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "accelerator-activated", (GCallback) _dbus_gala_dbus_accelerator_accelerator_activated, data);
	return result;
}

static void
_gala_dbus_accelerator_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_gala_dbus_accelerator_accelerator_activated, data);
	gala_dbus_accelerator_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

