/* SelectionArea.c generated by valac 0.43.92, the Vala compiler
 * generated from SelectionArea.vala, do not modify */

/**/
/*  Copyright (C) 2017 Santiago León O., Adam Bieńkowski*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <clutter/clutter.h>
#include <glib-object.h>
#include "gala.h"
#include <glib.h>
#include <gdk/gdk.h>
#include <meta/meta-plugin.h>
#include <meta/screen.h>
#include <meta/common.h>
#include <stdlib.h>
#include <cairo.h>
#include <float.h>
#include <math.h>

#define GALA_TYPE_SELECTION_AREA (gala_selection_area_get_type ())
#define GALA_SELECTION_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_SELECTION_AREA, GalaSelectionArea))
#define GALA_SELECTION_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_SELECTION_AREA, GalaSelectionAreaClass))
#define GALA_IS_SELECTION_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_SELECTION_AREA))
#define GALA_IS_SELECTION_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_SELECTION_AREA))
#define GALA_SELECTION_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_SELECTION_AREA, GalaSelectionAreaClass))

typedef struct _GalaSelectionArea GalaSelectionArea;
typedef struct _GalaSelectionAreaClass GalaSelectionAreaClass;
typedef struct _GalaSelectionAreaPrivate GalaSelectionAreaPrivate;
enum  {
	GALA_SELECTION_AREA_0_PROPERTY,
	GALA_SELECTION_AREA_WM_PROPERTY,
	GALA_SELECTION_AREA_CANCELLED_PROPERTY,
	GALA_SELECTION_AREA_NUM_PROPERTIES
};
static GParamSpec* gala_selection_area_properties[GALA_SELECTION_AREA_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	GALA_SELECTION_AREA_CLOSED_SIGNAL,
	GALA_SELECTION_AREA_NUM_SIGNALS
};
static guint gala_selection_area_signals[GALA_SELECTION_AREA_NUM_SIGNALS] = {0};

struct _GalaSelectionArea {
	ClutterActor parent_instance;
	GalaSelectionAreaPrivate * priv;
};

struct _GalaSelectionAreaClass {
	ClutterActorClass parent_class;
};

struct _GalaSelectionAreaPrivate {
	GalaWindowManager* _wm;
	gboolean _cancelled;
	GalaModalProxy* modal_proxy;
	GdkPoint start_point;
	GdkPoint end_point;
	gboolean dragging;
	gboolean clicked;
};

static gint GalaSelectionArea_private_offset;
static gpointer gala_selection_area_parent_class = NULL;

GType gala_selection_area_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaSelectionArea, g_object_unref)
GalaSelectionArea* gala_selection_area_new (GalaWindowManager* wm);
GalaSelectionArea* gala_selection_area_construct (GType object_type,
                                                  GalaWindowManager* wm);
static gboolean gala_selection_area_real_key_press_event (ClutterActor* base,
                                                   ClutterKeyEvent* e);
void gala_selection_area_close (GalaSelectionArea* self);
static void gala_selection_area_set_cancelled (GalaSelectionArea* self,
                                        gboolean value);
static gboolean gala_selection_area_real_button_press_event (ClutterActor* base,
                                                      ClutterButtonEvent* e);
static gboolean gala_selection_area_real_button_release_event (ClutterActor* base,
                                                        ClutterButtonEvent* e);
static gboolean gala_selection_area_real_motion_event (ClutterActor* base,
                                                ClutterMotionEvent* e);
GalaWindowManager* gala_selection_area_get_wm (GalaSelectionArea* self);
void gala_selection_area_start_selection (GalaSelectionArea* self);
void gala_selection_area_get_selection_rectangle (GalaSelectionArea* self,
                                                  gint* x,
                                                  gint* y,
                                                  gint* width,
                                                  gint* height);
static gboolean gala_selection_area_draw_area (GalaSelectionArea* self,
                                        cairo_t* ctx);
static void gala_selection_area_set_wm (GalaSelectionArea* self,
                                 GalaWindowManager* value);
gboolean gala_selection_area_get_cancelled (GalaSelectionArea* self);
static GObject * gala_selection_area_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static gboolean _gala_selection_area_draw_area_clutter_canvas_draw (ClutterCanvas* _sender,
                                                             cairo_t* cr,
                                                             gint width,
                                                             gint height,
                                                             gpointer self);
static void gala_selection_area_finalize (GObject * obj);
static void _vala_gala_selection_area_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_gala_selection_area_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
gala_selection_area_get_instance_private (GalaSelectionArea* self)
{
	return G_STRUCT_MEMBER_P (self, GalaSelectionArea_private_offset);
}

GalaSelectionArea*
gala_selection_area_construct (GType object_type,
                               GalaWindowManager* wm)
{
	GalaSelectionArea * self = NULL;
#line 34 "../src/Widgets/SelectionArea.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 36 "../src/Widgets/SelectionArea.vala"
	self = (GalaSelectionArea*) g_object_new (object_type, "wm", wm, NULL);
#line 34 "../src/Widgets/SelectionArea.vala"
	return self;
#line 144 "SelectionArea.c"
}

GalaSelectionArea*
gala_selection_area_new (GalaWindowManager* wm)
{
#line 34 "../src/Widgets/SelectionArea.vala"
	return gala_selection_area_construct (GALA_TYPE_SELECTION_AREA, wm);
#line 152 "SelectionArea.c"
}

static gboolean
gala_selection_area_real_key_press_event (ClutterActor* base,
                                          ClutterKeyEvent* e)
{
	GalaSelectionArea * self;
	gboolean result = FALSE;
#line 59 "../src/Widgets/SelectionArea.vala"
	self = (GalaSelectionArea*) base;
#line 59 "../src/Widgets/SelectionArea.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 61 "../src/Widgets/SelectionArea.vala"
	if (e->keyval == ((guint) CLUTTER_KEY_Escape)) {
#line 62 "../src/Widgets/SelectionArea.vala"
		gala_selection_area_close (self);
#line 63 "../src/Widgets/SelectionArea.vala"
		gala_selection_area_set_cancelled (self, TRUE);
#line 64 "../src/Widgets/SelectionArea.vala"
		g_signal_emit (self, gala_selection_area_signals[GALA_SELECTION_AREA_CLOSED_SIGNAL], 0);
#line 65 "../src/Widgets/SelectionArea.vala"
		result = TRUE;
#line 65 "../src/Widgets/SelectionArea.vala"
		return result;
#line 177 "SelectionArea.c"
	}
#line 68 "../src/Widgets/SelectionArea.vala"
	result = FALSE;
#line 68 "../src/Widgets/SelectionArea.vala"
	return result;
#line 183 "SelectionArea.c"
}

static gboolean
gala_selection_area_real_button_press_event (ClutterActor* base,
                                             ClutterButtonEvent* e)
{
	GalaSelectionArea * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 71 "../src/Widgets/SelectionArea.vala"
	self = (GalaSelectionArea*) base;
#line 71 "../src/Widgets/SelectionArea.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 73 "../src/Widgets/SelectionArea.vala"
	if (self->priv->dragging) {
#line 73 "../src/Widgets/SelectionArea.vala"
		_tmp0_ = TRUE;
#line 201 "SelectionArea.c"
	} else {
#line 73 "../src/Widgets/SelectionArea.vala"
		_tmp0_ = e->button != ((guint32) 1);
#line 205 "SelectionArea.c"
	}
#line 73 "../src/Widgets/SelectionArea.vala"
	if (_tmp0_) {
#line 74 "../src/Widgets/SelectionArea.vala"
		result = TRUE;
#line 74 "../src/Widgets/SelectionArea.vala"
		return result;
#line 213 "SelectionArea.c"
	}
#line 77 "../src/Widgets/SelectionArea.vala"
	self->priv->clicked = TRUE;
#line 79 "../src/Widgets/SelectionArea.vala"
	self->priv->start_point.x = (gint) e->x;
#line 80 "../src/Widgets/SelectionArea.vala"
	self->priv->start_point.y = (gint) e->y;
#line 82 "../src/Widgets/SelectionArea.vala"
	result = TRUE;
#line 82 "../src/Widgets/SelectionArea.vala"
	return result;
#line 225 "SelectionArea.c"
}

static gboolean
gala_selection_area_real_button_release_event (ClutterActor* base,
                                               ClutterButtonEvent* e)
{
	GalaSelectionArea * self;
	gboolean result = FALSE;
	ClutterContent* _tmp0_;
	ClutterContent* _tmp1_;
#line 85 "../src/Widgets/SelectionArea.vala"
	self = (GalaSelectionArea*) base;
#line 85 "../src/Widgets/SelectionArea.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 87 "../src/Widgets/SelectionArea.vala"
	if (e->button != ((guint32) 1)) {
#line 88 "../src/Widgets/SelectionArea.vala"
		result = TRUE;
#line 88 "../src/Widgets/SelectionArea.vala"
		return result;
#line 246 "SelectionArea.c"
	}
#line 91 "../src/Widgets/SelectionArea.vala"
	if (!self->priv->dragging) {
#line 92 "../src/Widgets/SelectionArea.vala"
		gala_selection_area_close (self);
#line 93 "../src/Widgets/SelectionArea.vala"
		gala_selection_area_set_cancelled (self, TRUE);
#line 94 "../src/Widgets/SelectionArea.vala"
		g_signal_emit (self, gala_selection_area_signals[GALA_SELECTION_AREA_CLOSED_SIGNAL], 0);
#line 95 "../src/Widgets/SelectionArea.vala"
		result = TRUE;
#line 95 "../src/Widgets/SelectionArea.vala"
		return result;
#line 260 "SelectionArea.c"
	}
#line 98 "../src/Widgets/SelectionArea.vala"
	self->priv->dragging = FALSE;
#line 99 "../src/Widgets/SelectionArea.vala"
	self->priv->clicked = FALSE;
#line 101 "../src/Widgets/SelectionArea.vala"
	gala_selection_area_close (self);
#line 102 "../src/Widgets/SelectionArea.vala"
	clutter_actor_hide ((ClutterActor*) self);
#line 103 "../src/Widgets/SelectionArea.vala"
	_tmp0_ = clutter_actor_get_content ((ClutterActor*) self);
#line 103 "../src/Widgets/SelectionArea.vala"
	_tmp1_ = _tmp0_;
#line 103 "../src/Widgets/SelectionArea.vala"
	clutter_content_invalidate (_tmp1_);
#line 105 "../src/Widgets/SelectionArea.vala"
	g_signal_emit (self, gala_selection_area_signals[GALA_SELECTION_AREA_CLOSED_SIGNAL], 0);
#line 106 "../src/Widgets/SelectionArea.vala"
	result = TRUE;
#line 106 "../src/Widgets/SelectionArea.vala"
	return result;
#line 282 "SelectionArea.c"
}

static gboolean
gala_selection_area_real_motion_event (ClutterActor* base,
                                       ClutterMotionEvent* e)
{
	GalaSelectionArea * self;
	gboolean result = FALSE;
	ClutterContent* _tmp0_;
	ClutterContent* _tmp1_;
#line 109 "../src/Widgets/SelectionArea.vala"
	self = (GalaSelectionArea*) base;
#line 109 "../src/Widgets/SelectionArea.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 111 "../src/Widgets/SelectionArea.vala"
	if (!self->priv->clicked) {
#line 112 "../src/Widgets/SelectionArea.vala"
		result = TRUE;
#line 112 "../src/Widgets/SelectionArea.vala"
		return result;
#line 303 "SelectionArea.c"
	}
#line 115 "../src/Widgets/SelectionArea.vala"
	self->priv->end_point.x = (gint) e->x;
#line 116 "../src/Widgets/SelectionArea.vala"
	self->priv->end_point.y = (gint) e->y;
#line 117 "../src/Widgets/SelectionArea.vala"
	_tmp0_ = clutter_actor_get_content ((ClutterActor*) self);
#line 117 "../src/Widgets/SelectionArea.vala"
	_tmp1_ = _tmp0_;
#line 117 "../src/Widgets/SelectionArea.vala"
	clutter_content_invalidate (_tmp1_);
#line 119 "../src/Widgets/SelectionArea.vala"
	if (!self->priv->dragging) {
#line 120 "../src/Widgets/SelectionArea.vala"
		self->priv->dragging = TRUE;
#line 319 "SelectionArea.c"
	}
#line 123 "../src/Widgets/SelectionArea.vala"
	result = TRUE;
#line 123 "../src/Widgets/SelectionArea.vala"
	return result;
#line 325 "SelectionArea.c"
}

void
gala_selection_area_close (GalaSelectionArea* self)
{
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	GalaModalProxy* _tmp2_;
#line 126 "../src/Widgets/SelectionArea.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/Widgets/SelectionArea.vala"
	_tmp0_ = self->priv->_wm;
#line 128 "../src/Widgets/SelectionArea.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 128 "../src/Widgets/SelectionArea.vala"
	meta_screen_set_cursor (_tmp1_, META_CURSOR_DEFAULT);
#line 130 "../src/Widgets/SelectionArea.vala"
	_tmp2_ = self->priv->modal_proxy;
#line 130 "../src/Widgets/SelectionArea.vala"
	if (_tmp2_ != NULL) {
#line 346 "SelectionArea.c"
		GalaWindowManager* _tmp3_;
		GalaModalProxy* _tmp4_;
#line 131 "../src/Widgets/SelectionArea.vala"
		_tmp3_ = self->priv->_wm;
#line 131 "../src/Widgets/SelectionArea.vala"
		_tmp4_ = self->priv->modal_proxy;
#line 131 "../src/Widgets/SelectionArea.vala"
		gala_window_manager_pop_modal (_tmp3_, _tmp4_);
#line 355 "SelectionArea.c"
	}
}

void
gala_selection_area_start_selection (GalaSelectionArea* self)
{
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	GalaWindowManager* _tmp2_;
	GalaModalProxy* _tmp3_;
#line 135 "../src/Widgets/SelectionArea.vala"
	g_return_if_fail (self != NULL);
#line 137 "../src/Widgets/SelectionArea.vala"
	_tmp0_ = self->priv->_wm;
#line 137 "../src/Widgets/SelectionArea.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 137 "../src/Widgets/SelectionArea.vala"
	meta_screen_set_cursor (_tmp1_, META_CURSOR_CROSSHAIR);
#line 138 "../src/Widgets/SelectionArea.vala"
	clutter_actor_grab_key_focus ((ClutterActor*) self);
#line 140 "../src/Widgets/SelectionArea.vala"
	_tmp2_ = self->priv->_wm;
#line 140 "../src/Widgets/SelectionArea.vala"
	_tmp3_ = gala_window_manager_push_modal (_tmp2_);
#line 140 "../src/Widgets/SelectionArea.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 140 "../src/Widgets/SelectionArea.vala"
	self->priv->modal_proxy = _tmp3_;
#line 384 "SelectionArea.c"
}

void
gala_selection_area_get_selection_rectangle (GalaSelectionArea* self,
                                             gint* x,
                                             gint* y,
                                             gint* width,
                                             gint* height)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	gint _vala_width = 0;
	gint _vala_height = 0;
	GdkPoint _tmp0_;
	GdkPoint _tmp1_;
	GdkPoint _tmp2_;
	GdkPoint _tmp3_;
	GdkPoint _tmp4_;
	GdkPoint _tmp5_;
	GdkPoint _tmp6_;
	GdkPoint _tmp7_;
#line 143 "../src/Widgets/SelectionArea.vala"
	g_return_if_fail (self != NULL);
#line 145 "../src/Widgets/SelectionArea.vala"
	_tmp0_ = self->priv->start_point;
#line 145 "../src/Widgets/SelectionArea.vala"
	_tmp1_ = self->priv->end_point;
#line 145 "../src/Widgets/SelectionArea.vala"
	_vala_x = MIN (_tmp0_.x, _tmp1_.x);
#line 146 "../src/Widgets/SelectionArea.vala"
	_tmp2_ = self->priv->start_point;
#line 146 "../src/Widgets/SelectionArea.vala"
	_tmp3_ = self->priv->end_point;
#line 146 "../src/Widgets/SelectionArea.vala"
	_vala_y = MIN (_tmp2_.y, _tmp3_.y);
#line 147 "../src/Widgets/SelectionArea.vala"
	_tmp4_ = self->priv->start_point;
#line 147 "../src/Widgets/SelectionArea.vala"
	_tmp5_ = self->priv->end_point;
#line 147 "../src/Widgets/SelectionArea.vala"
	_vala_width = abs (_tmp4_.x - _tmp5_.x);
#line 148 "../src/Widgets/SelectionArea.vala"
	_tmp6_ = self->priv->start_point;
#line 148 "../src/Widgets/SelectionArea.vala"
	_tmp7_ = self->priv->end_point;
#line 148 "../src/Widgets/SelectionArea.vala"
	_vala_height = abs (_tmp6_.y - _tmp7_.y);
#line 143 "../src/Widgets/SelectionArea.vala"
	if (x) {
#line 143 "../src/Widgets/SelectionArea.vala"
		*x = _vala_x;
#line 436 "SelectionArea.c"
	}
#line 143 "../src/Widgets/SelectionArea.vala"
	if (y) {
#line 143 "../src/Widgets/SelectionArea.vala"
		*y = _vala_y;
#line 442 "SelectionArea.c"
	}
#line 143 "../src/Widgets/SelectionArea.vala"
	if (width) {
#line 143 "../src/Widgets/SelectionArea.vala"
		*width = _vala_width;
#line 448 "SelectionArea.c"
	}
#line 143 "../src/Widgets/SelectionArea.vala"
	if (height) {
#line 143 "../src/Widgets/SelectionArea.vala"
		*height = _vala_height;
#line 454 "SelectionArea.c"
	}
}

static gboolean
gala_selection_area_draw_area (GalaSelectionArea* self,
                               cairo_t* ctx)
{
	gboolean result = FALSE;
	gint x = 0;
	gint y = 0;
	gint w = 0;
	gint h = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
#line 151 "../src/Widgets/SelectionArea.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 151 "../src/Widgets/SelectionArea.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 153 "../src/Widgets/SelectionArea.vala"
	clutter_cairo_clear (ctx);
#line 155 "../src/Widgets/SelectionArea.vala"
	if (!self->priv->dragging) {
#line 156 "../src/Widgets/SelectionArea.vala"
		result = TRUE;
#line 156 "../src/Widgets/SelectionArea.vala"
		return result;
#line 483 "SelectionArea.c"
	}
#line 160 "../src/Widgets/SelectionArea.vala"
	gala_selection_area_get_selection_rectangle (self, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 160 "../src/Widgets/SelectionArea.vala"
	x = _tmp0_;
#line 160 "../src/Widgets/SelectionArea.vala"
	y = _tmp1_;
#line 160 "../src/Widgets/SelectionArea.vala"
	w = _tmp2_;
#line 160 "../src/Widgets/SelectionArea.vala"
	h = _tmp3_;
#line 162 "../src/Widgets/SelectionArea.vala"
	cairo_rectangle (ctx, (gdouble) x, (gdouble) y, (gdouble) w, (gdouble) h);
#line 163 "../src/Widgets/SelectionArea.vala"
	cairo_set_source_rgba (ctx, 0.1, 0.1, 0.1, 0.2);
#line 164 "../src/Widgets/SelectionArea.vala"
	cairo_fill (ctx);
#line 166 "../src/Widgets/SelectionArea.vala"
	cairo_rectangle (ctx, (gdouble) x, (gdouble) y, (gdouble) w, (gdouble) h);
#line 167 "../src/Widgets/SelectionArea.vala"
	cairo_set_source_rgb (ctx, 0.7, 0.7, 0.7);
#line 168 "../src/Widgets/SelectionArea.vala"
	cairo_set_line_width (ctx, 1.0);
#line 169 "../src/Widgets/SelectionArea.vala"
	cairo_stroke (ctx);
#line 171 "../src/Widgets/SelectionArea.vala"
	result = TRUE;
#line 171 "../src/Widgets/SelectionArea.vala"
	return result;
#line 513 "SelectionArea.c"
}

GalaWindowManager*
gala_selection_area_get_wm (GalaSelectionArea* self)
{
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
#line 24 "../src/Widgets/SelectionArea.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/Widgets/SelectionArea.vala"
	_tmp0_ = self->priv->_wm;
#line 24 "../src/Widgets/SelectionArea.vala"
	result = _tmp0_;
#line 24 "../src/Widgets/SelectionArea.vala"
	return result;
#line 529 "SelectionArea.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 24 "../src/Widgets/SelectionArea.vala"
	return self ? g_object_ref (self) : NULL;
#line 537 "SelectionArea.c"
}

static void
gala_selection_area_set_wm (GalaSelectionArea* self,
                            GalaWindowManager* value)
{
#line 24 "../src/Widgets/SelectionArea.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Widgets/SelectionArea.vala"
	if (gala_selection_area_get_wm (self) != value) {
#line 548 "SelectionArea.c"
		GalaWindowManager* _tmp0_;
#line 24 "../src/Widgets/SelectionArea.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 24 "../src/Widgets/SelectionArea.vala"
		_g_object_unref0 (self->priv->_wm);
#line 24 "../src/Widgets/SelectionArea.vala"
		self->priv->_wm = _tmp0_;
#line 24 "../src/Widgets/SelectionArea.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_selection_area_properties[GALA_SELECTION_AREA_WM_PROPERTY]);
#line 558 "SelectionArea.c"
	}
}

gboolean
gala_selection_area_get_cancelled (GalaSelectionArea* self)
{
	gboolean result;
#line 26 "../src/Widgets/SelectionArea.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 26 "../src/Widgets/SelectionArea.vala"
	result = self->priv->_cancelled;
#line 26 "../src/Widgets/SelectionArea.vala"
	return result;
#line 572 "SelectionArea.c"
}

static void
gala_selection_area_set_cancelled (GalaSelectionArea* self,
                                   gboolean value)
{
#line 26 "../src/Widgets/SelectionArea.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/Widgets/SelectionArea.vala"
	if (gala_selection_area_get_cancelled (self) != value) {
#line 26 "../src/Widgets/SelectionArea.vala"
		self->priv->_cancelled = value;
#line 26 "../src/Widgets/SelectionArea.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_selection_area_properties[GALA_SELECTION_AREA_CANCELLED_PROPERTY]);
#line 587 "SelectionArea.c"
	}
}

static gboolean
_gala_selection_area_draw_area_clutter_canvas_draw (ClutterCanvas* _sender,
                                                    cairo_t* cr,
                                                    gint width,
                                                    gint height,
                                                    gpointer self)
{
	gboolean result;
	result = gala_selection_area_draw_area ((GalaSelectionArea*) self, cr);
#line 53 "../src/Widgets/SelectionArea.vala"
	return result;
#line 602 "SelectionArea.c"
}

static GObject *
gala_selection_area_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaSelectionArea * self;
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_ = {0};
	gint screen_width = 0;
	gint screen_height = 0;
	GalaWindowManager* _tmp2_;
	MetaScreen* _tmp3_;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	ClutterCanvas* canvas = NULL;
	ClutterCanvas* _tmp6_;
	ClutterCanvas* _tmp7_;
	ClutterCanvas* _tmp8_;
	ClutterCanvas* _tmp9_;
	ClutterCanvas* _tmp10_;
#line 39 "../src/Widgets/SelectionArea.vala"
	parent_class = G_OBJECT_CLASS (gala_selection_area_parent_class);
#line 39 "../src/Widgets/SelectionArea.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 39 "../src/Widgets/SelectionArea.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_SELECTION_AREA, GalaSelectionArea);
#line 41 "../src/Widgets/SelectionArea.vala"
	_tmp0_.x = 0;
#line 41 "../src/Widgets/SelectionArea.vala"
	_tmp0_.y = 0;
#line 41 "../src/Widgets/SelectionArea.vala"
	self->priv->start_point = _tmp0_;
#line 42 "../src/Widgets/SelectionArea.vala"
	_tmp1_.x = 0;
#line 42 "../src/Widgets/SelectionArea.vala"
	_tmp1_.y = 0;
#line 42 "../src/Widgets/SelectionArea.vala"
	self->priv->end_point = _tmp1_;
#line 43 "../src/Widgets/SelectionArea.vala"
	g_object_set ((ClutterActor*) self, "visible", TRUE, NULL);
#line 44 "../src/Widgets/SelectionArea.vala"
	clutter_actor_set_reactive ((ClutterActor*) self, TRUE);
#line 47 "../src/Widgets/SelectionArea.vala"
	_tmp2_ = self->priv->_wm;
#line 47 "../src/Widgets/SelectionArea.vala"
	_tmp3_ = meta_plugin_get_screen ((MetaPlugin*) _tmp2_);
#line 47 "../src/Widgets/SelectionArea.vala"
	meta_screen_get_size (_tmp3_, &_tmp4_, &_tmp5_);
#line 47 "../src/Widgets/SelectionArea.vala"
	screen_width = _tmp4_;
#line 47 "../src/Widgets/SelectionArea.vala"
	screen_height = _tmp5_;
#line 48 "../src/Widgets/SelectionArea.vala"
	clutter_actor_set_width ((ClutterActor*) self, (gfloat) screen_width);
#line 49 "../src/Widgets/SelectionArea.vala"
	clutter_actor_set_height ((ClutterActor*) self, (gfloat) screen_height);
#line 51 "../src/Widgets/SelectionArea.vala"
	_tmp6_ = (ClutterCanvas*) clutter_canvas_new ();
#line 51 "../src/Widgets/SelectionArea.vala"
	canvas = _tmp6_;
#line 52 "../src/Widgets/SelectionArea.vala"
	_tmp7_ = canvas;
#line 52 "../src/Widgets/SelectionArea.vala"
	clutter_canvas_set_size (_tmp7_, screen_width, screen_height);
#line 53 "../src/Widgets/SelectionArea.vala"
	_tmp8_ = canvas;
#line 53 "../src/Widgets/SelectionArea.vala"
	g_signal_connect_object (_tmp8_, "draw", (GCallback) _gala_selection_area_draw_area_clutter_canvas_draw, self, 0);
#line 54 "../src/Widgets/SelectionArea.vala"
	_tmp9_ = canvas;
#line 54 "../src/Widgets/SelectionArea.vala"
	clutter_actor_set_content ((ClutterActor*) self, (ClutterContent*) _tmp9_);
#line 56 "../src/Widgets/SelectionArea.vala"
	_tmp10_ = canvas;
#line 56 "../src/Widgets/SelectionArea.vala"
	clutter_content_invalidate ((ClutterContent*) _tmp10_);
#line 39 "../src/Widgets/SelectionArea.vala"
	_g_object_unref0 (canvas);
#line 39 "../src/Widgets/SelectionArea.vala"
	return obj;
#line 687 "SelectionArea.c"
}

static void
gala_selection_area_class_init (GalaSelectionAreaClass * klass,
                                gpointer klass_data)
{
#line 20 "../src/Widgets/SelectionArea.vala"
	gala_selection_area_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Widgets/SelectionArea.vala"
	g_type_class_adjust_private_offset (klass, &GalaSelectionArea_private_offset);
#line 20 "../src/Widgets/SelectionArea.vala"
	((ClutterActorClass *) klass)->key_press_event = (gboolean (*) (ClutterActor*, ClutterKeyEvent*)) gala_selection_area_real_key_press_event;
#line 20 "../src/Widgets/SelectionArea.vala"
	((ClutterActorClass *) klass)->button_press_event = (gboolean (*) (ClutterActor*, ClutterButtonEvent*)) gala_selection_area_real_button_press_event;
#line 20 "../src/Widgets/SelectionArea.vala"
	((ClutterActorClass *) klass)->button_release_event = (gboolean (*) (ClutterActor*, ClutterButtonEvent*)) gala_selection_area_real_button_release_event;
#line 20 "../src/Widgets/SelectionArea.vala"
	((ClutterActorClass *) klass)->motion_event = (gboolean (*) (ClutterActor*, ClutterMotionEvent*)) gala_selection_area_real_motion_event;
#line 20 "../src/Widgets/SelectionArea.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_selection_area_get_property;
#line 20 "../src/Widgets/SelectionArea.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_selection_area_set_property;
#line 20 "../src/Widgets/SelectionArea.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_selection_area_constructor;
#line 20 "../src/Widgets/SelectionArea.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_selection_area_finalize;
#line 20 "../src/Widgets/SelectionArea.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_SELECTION_AREA_WM_PROPERTY, gala_selection_area_properties[GALA_SELECTION_AREA_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "../src/Widgets/SelectionArea.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_SELECTION_AREA_CANCELLED_PROPERTY, gala_selection_area_properties[GALA_SELECTION_AREA_CANCELLED_PROPERTY] = g_param_spec_boolean ("cancelled", "cancelled", "cancelled", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Widgets/SelectionArea.vala"
	gala_selection_area_signals[GALA_SELECTION_AREA_CLOSED_SIGNAL] = g_signal_new ("closed", GALA_TYPE_SELECTION_AREA, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 720 "SelectionArea.c"
}

static void
gala_selection_area_instance_init (GalaSelectionArea * self,
                                   gpointer klass)
{
#line 20 "../src/Widgets/SelectionArea.vala"
	self->priv = gala_selection_area_get_instance_private (self);
#line 31 "../src/Widgets/SelectionArea.vala"
	self->priv->dragging = FALSE;
#line 32 "../src/Widgets/SelectionArea.vala"
	self->priv->clicked = FALSE;
#line 733 "SelectionArea.c"
}

static void
gala_selection_area_finalize (GObject * obj)
{
	GalaSelectionArea * self;
#line 20 "../src/Widgets/SelectionArea.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_SELECTION_AREA, GalaSelectionArea);
#line 24 "../src/Widgets/SelectionArea.vala"
	_g_object_unref0 (self->priv->_wm);
#line 28 "../src/Widgets/SelectionArea.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 20 "../src/Widgets/SelectionArea.vala"
	G_OBJECT_CLASS (gala_selection_area_parent_class)->finalize (obj);
#line 748 "SelectionArea.c"
}

GType
gala_selection_area_get_type (void)
{
	static volatile gsize gala_selection_area_type_id__volatile = 0;
	if (g_once_init_enter (&gala_selection_area_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaSelectionAreaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_selection_area_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaSelectionArea), 0, (GInstanceInitFunc) gala_selection_area_instance_init, NULL };
		GType gala_selection_area_type_id;
		gala_selection_area_type_id = g_type_register_static (clutter_actor_get_type (), "GalaSelectionArea", &g_define_type_info, 0);
		GalaSelectionArea_private_offset = g_type_add_instance_private (gala_selection_area_type_id, sizeof (GalaSelectionAreaPrivate));
		g_once_init_leave (&gala_selection_area_type_id__volatile, gala_selection_area_type_id);
	}
	return gala_selection_area_type_id__volatile;
}

static void
_vala_gala_selection_area_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	GalaSelectionArea * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_SELECTION_AREA, GalaSelectionArea);
#line 20 "../src/Widgets/SelectionArea.vala"
	switch (property_id) {
#line 20 "../src/Widgets/SelectionArea.vala"
		case GALA_SELECTION_AREA_WM_PROPERTY:
#line 20 "../src/Widgets/SelectionArea.vala"
		g_value_set_object (value, gala_selection_area_get_wm (self));
#line 20 "../src/Widgets/SelectionArea.vala"
		break;
#line 20 "../src/Widgets/SelectionArea.vala"
		case GALA_SELECTION_AREA_CANCELLED_PROPERTY:
#line 20 "../src/Widgets/SelectionArea.vala"
		g_value_set_boolean (value, gala_selection_area_get_cancelled (self));
#line 20 "../src/Widgets/SelectionArea.vala"
		break;
#line 787 "SelectionArea.c"
		default:
#line 20 "../src/Widgets/SelectionArea.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Widgets/SelectionArea.vala"
		break;
#line 793 "SelectionArea.c"
	}
}

static void
_vala_gala_selection_area_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	GalaSelectionArea * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_SELECTION_AREA, GalaSelectionArea);
#line 20 "../src/Widgets/SelectionArea.vala"
	switch (property_id) {
#line 20 "../src/Widgets/SelectionArea.vala"
		case GALA_SELECTION_AREA_WM_PROPERTY:
#line 20 "../src/Widgets/SelectionArea.vala"
		gala_selection_area_set_wm (self, g_value_get_object (value));
#line 20 "../src/Widgets/SelectionArea.vala"
		break;
#line 20 "../src/Widgets/SelectionArea.vala"
		case GALA_SELECTION_AREA_CANCELLED_PROPERTY:
#line 20 "../src/Widgets/SelectionArea.vala"
		gala_selection_area_set_cancelled (self, g_value_get_boolean (value));
#line 20 "../src/Widgets/SelectionArea.vala"
		break;
#line 819 "SelectionArea.c"
		default:
#line 20 "../src/Widgets/SelectionArea.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Widgets/SelectionArea.vala"
		break;
#line 825 "SelectionArea.c"
	}
}

