/* WorkspaceManager.c generated by valac 0.43.92, the Vala compiler
 * generated from WorkspaceManager.vala, do not modify */

/**/
/*  Copyright (C) 2014 Tom Beckmann, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib-object.h>
#include "gala.h"
#include <gee.h>
#include <meta/workspace.h>
#include <glib.h>
#include <meta/screen.h>
#include <meta/meta-plugin.h>
#include <meta/prefs.h>
#include <meta/common.h>
#include <meta/window.h>
#include <meta/display.h>

#define GALA_TYPE_WORKSPACE_MANAGER (gala_workspace_manager_get_type ())
#define GALA_WORKSPACE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager))
#define GALA_WORKSPACE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManagerClass))
#define GALA_IS_WORKSPACE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WORKSPACE_MANAGER))
#define GALA_IS_WORKSPACE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WORKSPACE_MANAGER))
#define GALA_WORKSPACE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManagerClass))

typedef struct _GalaWorkspaceManager GalaWorkspaceManager;
typedef struct _GalaWorkspaceManagerClass GalaWorkspaceManagerClass;
typedef struct _GalaWorkspaceManagerPrivate GalaWorkspaceManagerPrivate;
enum  {
	GALA_WORKSPACE_MANAGER_0_PROPERTY,
	GALA_WORKSPACE_MANAGER_WM_PROPERTY,
	GALA_WORKSPACE_MANAGER_NUM_PROPERTIES
};
static GParamSpec* gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GalaWorkspaceManager {
	GObject parent_instance;
	GalaWorkspaceManagerPrivate * priv;
};

struct _GalaWorkspaceManagerClass {
	GObjectClass parent_class;
};

struct _GalaWorkspaceManagerPrivate {
	GalaWindowManager* _wm;
	GeeLinkedList* workspaces_marked_removed;
	gint remove_freeze_count;
};

static gint GalaWorkspaceManager_private_offset;
static gpointer gala_workspace_manager_parent_class = NULL;
static GalaWorkspaceManager* gala_workspace_manager_instance;
static GalaWorkspaceManager* gala_workspace_manager_instance = NULL;

GType gala_workspace_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWorkspaceManager, g_object_unref)
GalaWindowManager* gala_workspace_manager_get_wm (GalaWorkspaceManager* self);
static void gala_workspace_manager_prefs_listener (GalaWorkspaceManager* self,
                                            MetaPreference pref);
static void _gala_workspace_manager_prefs_listener_meta_prefs_changed_func (MetaPreference pref,
                                                                     gpointer self);
static void gala_workspace_manager_workspace_added (GalaWorkspaceManager* self,
                                             MetaScreen* screen,
                                             gint index);
static void _gala_workspace_manager_workspace_added_meta_screen_workspace_added (MetaScreen* _sender,
                                                                          gint object,
                                                                          gpointer self);
static void gala_workspace_manager_workspace_switched (GalaWorkspaceManager* self,
                                                MetaScreen* screen,
                                                gint from,
                                                gint to,
                                                MetaMotionDirection direction);
static void _gala_workspace_manager_workspace_switched_meta_screen_workspace_switched (MetaScreen* _sender,
                                                                                gint object,
                                                                                gint p0,
                                                                                MetaMotionDirection p1,
                                                                                gpointer self);
static void gala_workspace_manager_workspace_removed (GalaWorkspaceManager* self,
                                               MetaScreen* screen,
                                               gint index);
static void _gala_workspace_manager_workspace_removed_meta_screen_workspace_removed (MetaScreen* _sender,
                                                                              gint object,
                                                                              gpointer self);
static void gala_workspace_manager_window_entered_monitor (GalaWorkspaceManager* self,
                                                    MetaScreen* screen,
                                                    gint monitor,
                                                    MetaWindow* window);
static void _gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor (MetaScreen* _sender,
                                                                                        gint object,
                                                                                        MetaWindow* p0,
                                                                                        gpointer self);
static void gala_workspace_manager_window_left_monitor (GalaWorkspaceManager* self,
                                                 MetaScreen* screen,
                                                 gint monitor,
                                                 MetaWindow* window);
static void _gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor (MetaScreen* _sender,
                                                                                  gint object,
                                                                                  MetaWindow* p0,
                                                                                  gpointer self);
void gala_workspace_manager_init (GalaWindowManager* wm);
static GalaWorkspaceManager* gala_workspace_manager_new (GalaWindowManager* wm);
static GalaWorkspaceManager* gala_workspace_manager_construct (GType object_type,
                                                        GalaWindowManager* wm);
GalaWorkspaceManager* gala_workspace_manager_get_default (void);
static void gala_workspace_manager_window_added (GalaWorkspaceManager* self,
                                          MetaWorkspace* workspace,
                                          MetaWindow* window);
static void _gala_workspace_manager_window_added_meta_workspace_window_added (MetaWorkspace* _sender,
                                                                       MetaWindow* object,
                                                                       gpointer self);
static void gala_workspace_manager_window_removed (GalaWorkspaceManager* self,
                                            MetaWorkspace* workspace,
                                            MetaWindow* window);
static void _gala_workspace_manager_window_removed_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                           MetaWindow* object,
                                                                           gpointer self);
static void gala_workspace_manager_remove_workspace (GalaWorkspaceManager* self,
                                              MetaWorkspace* workspace);
static void gala_workspace_manager_append_workspace (GalaWorkspaceManager* self);
gboolean gala_internal_utils_workspaces_only_on_primary (void);
void gala_workspace_manager_freeze_remove (GalaWorkspaceManager* self);
void gala_workspace_manager_thaw_remove (GalaWorkspaceManager* self);
void gala_workspace_manager_cleanup (GalaWorkspaceManager* self);
static void gala_workspace_manager_set_wm (GalaWorkspaceManager* self,
                                    GalaWindowManager* value);
static GObject * gala_workspace_manager_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void gala_workspace_manager_finalize (GObject * obj);
static void _vala_gala_workspace_manager_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_gala_workspace_manager_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
gala_workspace_manager_get_instance_private (GalaWorkspaceManager* self)
{
	return G_STRUCT_MEMBER_P (self, GalaWorkspaceManager_private_offset);
}

static void
_gala_workspace_manager_prefs_listener_meta_prefs_changed_func (MetaPreference pref,
                                                                gpointer self)
{
#line 81 "../src/WorkspaceManager.vala"
	gala_workspace_manager_prefs_listener ((GalaWorkspaceManager*) self, pref);
#line 172 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_workspace_added_meta_screen_workspace_added (MetaScreen* _sender,
                                                                     gint object,
                                                                     gpointer self)
{
#line 83 "../src/WorkspaceManager.vala"
	gala_workspace_manager_workspace_added ((GalaWorkspaceManager*) self, _sender, object);
#line 182 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_workspace_switched_meta_screen_workspace_switched (MetaScreen* _sender,
                                                                           gint object,
                                                                           gint p0,
                                                                           MetaMotionDirection p1,
                                                                           gpointer self)
{
#line 84 "../src/WorkspaceManager.vala"
	gala_workspace_manager_workspace_switched ((GalaWorkspaceManager*) self, _sender, object, p0, p1);
#line 194 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_workspace_removed_meta_screen_workspace_removed (MetaScreen* _sender,
                                                                         gint object,
                                                                         gpointer self)
{
#line 85 "../src/WorkspaceManager.vala"
	gala_workspace_manager_workspace_removed ((GalaWorkspaceManager*) self, _sender, object);
#line 204 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor (MetaScreen* _sender,
                                                                                   gint object,
                                                                                   MetaWindow* p0,
                                                                                   gpointer self)
{
#line 86 "../src/WorkspaceManager.vala"
	gala_workspace_manager_window_entered_monitor ((GalaWorkspaceManager*) self, _sender, object, p0);
#line 215 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor (MetaScreen* _sender,
                                                                             gint object,
                                                                             MetaWindow* p0,
                                                                             gpointer self)
{
#line 87 "../src/WorkspaceManager.vala"
	gala_workspace_manager_window_left_monitor ((GalaWorkspaceManager*) self, _sender, object, p0);
#line 226 "WorkspaceManager.c"
}

void
gala_workspace_manager_init (GalaWindowManager* wm)
{
	GalaWorkspaceManager* _tmp0_;
	GalaWorkspaceManager* _tmp1_;
#line 24 "../src/WorkspaceManager.vala"
	g_return_if_fail (wm != NULL);
#line 24 "../src/WorkspaceManager.vala"
	_tmp0_ = gala_workspace_manager_instance;
#line 24 "../src/WorkspaceManager.vala"
	_vala_return_if_fail (_tmp0_ == NULL, "instance == null");
#line 27 "../src/WorkspaceManager.vala"
	_tmp1_ = gala_workspace_manager_new (wm);
#line 27 "../src/WorkspaceManager.vala"
	_g_object_unref0 (gala_workspace_manager_instance);
#line 27 "../src/WorkspaceManager.vala"
	gala_workspace_manager_instance = _tmp1_;
#line 246 "WorkspaceManager.c"
}

GalaWorkspaceManager*
gala_workspace_manager_get_default (void)
{
	GalaWorkspaceManager* result = NULL;
	GalaWorkspaceManager* _tmp0_;
	GalaWorkspaceManager* _tmp1_;
#line 30 "../src/WorkspaceManager.vala"
	_tmp0_ = gala_workspace_manager_instance;
#line 30 "../src/WorkspaceManager.vala"
	_vala_return_val_if_fail (_tmp0_ != NULL, "instance != null", NULL);
#line 33 "../src/WorkspaceManager.vala"
	_tmp1_ = gala_workspace_manager_instance;
#line 33 "../src/WorkspaceManager.vala"
	result = _tmp1_;
#line 33 "../src/WorkspaceManager.vala"
	return result;
#line 265 "WorkspaceManager.c"
}

static GalaWorkspaceManager*
gala_workspace_manager_construct (GType object_type,
                                  GalaWindowManager* wm)
{
	GalaWorkspaceManager * self = NULL;
#line 43 "../src/WorkspaceManager.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 45 "../src/WorkspaceManager.vala"
	self = (GalaWorkspaceManager*) g_object_new (object_type, "wm", wm, NULL);
#line 43 "../src/WorkspaceManager.vala"
	return self;
#line 279 "WorkspaceManager.c"
}

static GalaWorkspaceManager*
gala_workspace_manager_new (GalaWindowManager* wm)
{
#line 43 "../src/WorkspaceManager.vala"
	return gala_workspace_manager_construct (GALA_TYPE_WORKSPACE_MANAGER, wm);
#line 287 "WorkspaceManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 92 "../src/WorkspaceManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 295 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_window_added_meta_workspace_window_added (MetaWorkspace* _sender,
                                                                  MetaWindow* object,
                                                                  gpointer self)
{
#line 96 "../src/WorkspaceManager.vala"
	gala_workspace_manager_window_added ((GalaWorkspaceManager*) self, _sender, object);
#line 305 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_window_removed_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                      MetaWindow* object,
                                                                      gpointer self)
{
#line 97 "../src/WorkspaceManager.vala"
	gala_workspace_manager_window_removed ((GalaWorkspaceManager*) self, _sender, object);
#line 315 "WorkspaceManager.c"
}

static void
gala_workspace_manager_workspace_added (GalaWorkspaceManager* self,
                                        MetaScreen* screen,
                                        gint index)
{
	MetaWorkspace* workspace = NULL;
	MetaWorkspace* _tmp0_;
	MetaWorkspace* _tmp1_;
	MetaWorkspace* _tmp2_;
	MetaWorkspace* _tmp3_;
	MetaWorkspace* _tmp4_;
#line 90 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 90 "../src/WorkspaceManager.vala"
	g_return_if_fail (screen != NULL);
#line 92 "../src/WorkspaceManager.vala"
	_tmp0_ = meta_screen_get_workspace_by_index (screen, index);
#line 92 "../src/WorkspaceManager.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 92 "../src/WorkspaceManager.vala"
	workspace = _tmp1_;
#line 93 "../src/WorkspaceManager.vala"
	_tmp2_ = workspace;
#line 93 "../src/WorkspaceManager.vala"
	if (_tmp2_ == NULL) {
#line 94 "../src/WorkspaceManager.vala"
		_g_object_unref0 (workspace);
#line 94 "../src/WorkspaceManager.vala"
		return;
#line 347 "WorkspaceManager.c"
	}
#line 96 "../src/WorkspaceManager.vala"
	_tmp3_ = workspace;
#line 96 "../src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp3_, "window-added", (GCallback) _gala_workspace_manager_window_added_meta_workspace_window_added, self, 0);
#line 97 "../src/WorkspaceManager.vala"
	_tmp4_ = workspace;
#line 97 "../src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp4_, "window-removed", (GCallback) _gala_workspace_manager_window_removed_meta_workspace_window_removed, self, 0);
#line 90 "../src/WorkspaceManager.vala"
	_g_object_unref0 (workspace);
#line 359 "WorkspaceManager.c"
}

static void
gala_workspace_manager_workspace_removed (GalaWorkspaceManager* self,
                                          MetaScreen* screen,
                                          gint index)
{
	GList* existing_workspaces = NULL;
	GList* _tmp0_;
	GeeIterator* it = NULL;
	GeeLinkedList* _tmp1_;
	GeeIterator* _tmp2_;
#line 100 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 100 "../src/WorkspaceManager.vala"
	g_return_if_fail (screen != NULL);
#line 102 "../src/WorkspaceManager.vala"
	_tmp0_ = meta_screen_get_workspaces (screen);
#line 102 "../src/WorkspaceManager.vala"
	existing_workspaces = _tmp0_;
#line 104 "../src/WorkspaceManager.vala"
	_tmp1_ = self->priv->workspaces_marked_removed;
#line 104 "../src/WorkspaceManager.vala"
	_tmp2_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp1_);
#line 104 "../src/WorkspaceManager.vala"
	it = _tmp2_;
#line 105 "../src/WorkspaceManager.vala"
	while (TRUE) {
#line 388 "WorkspaceManager.c"
		GeeIterator* _tmp3_;
		GList* _tmp4_;
		GeeIterator* _tmp5_;
		gpointer _tmp6_;
		MetaWorkspace* _tmp7_;
		gboolean _tmp8_;
#line 105 "../src/WorkspaceManager.vala"
		_tmp3_ = it;
#line 105 "../src/WorkspaceManager.vala"
		if (!gee_iterator_next (_tmp3_)) {
#line 105 "../src/WorkspaceManager.vala"
			break;
#line 401 "WorkspaceManager.c"
		}
#line 106 "../src/WorkspaceManager.vala"
		_tmp4_ = existing_workspaces;
#line 106 "../src/WorkspaceManager.vala"
		_tmp5_ = it;
#line 106 "../src/WorkspaceManager.vala"
		_tmp6_ = gee_iterator_get (_tmp5_);
#line 106 "../src/WorkspaceManager.vala"
		_tmp7_ = (MetaWorkspace*) _tmp6_;
#line 106 "../src/WorkspaceManager.vala"
		_tmp8_ = g_list_index (_tmp4_, _tmp7_) < 0;
#line 106 "../src/WorkspaceManager.vala"
		_g_object_unref0 (_tmp7_);
#line 106 "../src/WorkspaceManager.vala"
		if (_tmp8_) {
#line 417 "WorkspaceManager.c"
			GeeIterator* _tmp9_;
#line 107 "../src/WorkspaceManager.vala"
			_tmp9_ = it;
#line 107 "../src/WorkspaceManager.vala"
			gee_iterator_remove (_tmp9_);
#line 423 "WorkspaceManager.c"
		}
	}
#line 100 "../src/WorkspaceManager.vala"
	_g_object_unref0 (it);
#line 428 "WorkspaceManager.c"
}

static void
gala_workspace_manager_workspace_switched (GalaWorkspaceManager* self,
                                           MetaScreen* screen,
                                           gint from,
                                           gint to,
                                           MetaMotionDirection direction)
{
	MetaWorkspace* prev_workspace = NULL;
	MetaWorkspace* _tmp0_;
	MetaWorkspace* _tmp1_;
	gboolean _tmp2_ = FALSE;
	MetaWorkspace* _tmp3_;
#line 111 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 111 "../src/WorkspaceManager.vala"
	g_return_if_fail (screen != NULL);
#line 113 "../src/WorkspaceManager.vala"
	if (!meta_prefs_get_dynamic_workspaces ()) {
#line 114 "../src/WorkspaceManager.vala"
		return;
#line 451 "WorkspaceManager.c"
	}
#line 117 "../src/WorkspaceManager.vala"
	_tmp0_ = meta_screen_get_workspace_by_index (screen, from);
#line 117 "../src/WorkspaceManager.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 117 "../src/WorkspaceManager.vala"
	prev_workspace = _tmp1_;
#line 118 "../src/WorkspaceManager.vala"
	_tmp3_ = prev_workspace;
#line 118 "../src/WorkspaceManager.vala"
	if (gala_utils_get_n_windows (_tmp3_) < ((guint) 1)) {
#line 119 "../src/WorkspaceManager.vala"
		_tmp2_ = from != (meta_screen_get_n_workspaces (screen) - 1);
#line 465 "WorkspaceManager.c"
	} else {
#line 118 "../src/WorkspaceManager.vala"
		_tmp2_ = FALSE;
#line 469 "WorkspaceManager.c"
	}
#line 118 "../src/WorkspaceManager.vala"
	if (_tmp2_) {
#line 473 "WorkspaceManager.c"
		MetaWorkspace* _tmp4_;
#line 120 "../src/WorkspaceManager.vala"
		_tmp4_ = prev_workspace;
#line 120 "../src/WorkspaceManager.vala"
		gala_workspace_manager_remove_workspace (self, _tmp4_);
#line 479 "WorkspaceManager.c"
	}
#line 111 "../src/WorkspaceManager.vala"
	_g_object_unref0 (prev_workspace);
#line 483 "WorkspaceManager.c"
}

static void
gala_workspace_manager_window_added (GalaWorkspaceManager* self,
                                     MetaWorkspace* workspace,
                                     MetaWindow* window)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	MetaScreen* screen = NULL;
	MetaScreen* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	MetaWindowType _tmp8_;
	MetaWindowType _tmp9_;
#line 124 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 124 "../src/WorkspaceManager.vala"
	g_return_if_fail (window != NULL);
#line 126 "../src/WorkspaceManager.vala"
	if (workspace == NULL) {
#line 126 "../src/WorkspaceManager.vala"
		_tmp1_ = TRUE;
#line 508 "WorkspaceManager.c"
	} else {
#line 126 "../src/WorkspaceManager.vala"
		_tmp1_ = !meta_prefs_get_dynamic_workspaces ();
#line 512 "WorkspaceManager.c"
	}
#line 126 "../src/WorkspaceManager.vala"
	if (_tmp1_) {
#line 126 "../src/WorkspaceManager.vala"
		_tmp0_ = TRUE;
#line 518 "WorkspaceManager.c"
	} else {
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 127 "../src/WorkspaceManager.vala"
		g_object_get (window, "on-all-workspaces", &_tmp2_, NULL);
#line 127 "../src/WorkspaceManager.vala"
		_tmp3_ = _tmp2_;
#line 127 "../src/WorkspaceManager.vala"
		_tmp0_ = _tmp3_;
#line 528 "WorkspaceManager.c"
	}
#line 126 "../src/WorkspaceManager.vala"
	if (_tmp0_) {
#line 128 "../src/WorkspaceManager.vala"
		return;
#line 534 "WorkspaceManager.c"
	}
#line 130 "../src/WorkspaceManager.vala"
	_tmp4_ = meta_workspace_get_screen (workspace);
#line 130 "../src/WorkspaceManager.vala"
	screen = _tmp4_;
#line 132 "../src/WorkspaceManager.vala"
	_tmp8_ = meta_window_get_window_type (window);
#line 132 "../src/WorkspaceManager.vala"
	_tmp9_ = _tmp8_;
#line 132 "../src/WorkspaceManager.vala"
	if (_tmp9_ == META_WINDOW_NORMAL) {
#line 132 "../src/WorkspaceManager.vala"
		_tmp7_ = TRUE;
#line 548 "WorkspaceManager.c"
	} else {
		MetaWindowType _tmp10_;
		MetaWindowType _tmp11_;
#line 133 "../src/WorkspaceManager.vala"
		_tmp10_ = meta_window_get_window_type (window);
#line 133 "../src/WorkspaceManager.vala"
		_tmp11_ = _tmp10_;
#line 133 "../src/WorkspaceManager.vala"
		_tmp7_ = _tmp11_ == META_WINDOW_DIALOG;
#line 558 "WorkspaceManager.c"
	}
#line 132 "../src/WorkspaceManager.vala"
	if (_tmp7_) {
#line 132 "../src/WorkspaceManager.vala"
		_tmp6_ = TRUE;
#line 564 "WorkspaceManager.c"
	} else {
		MetaWindowType _tmp12_;
		MetaWindowType _tmp13_;
#line 134 "../src/WorkspaceManager.vala"
		_tmp12_ = meta_window_get_window_type (window);
#line 134 "../src/WorkspaceManager.vala"
		_tmp13_ = _tmp12_;
#line 134 "../src/WorkspaceManager.vala"
		_tmp6_ = _tmp13_ == META_WINDOW_MODAL_DIALOG;
#line 574 "WorkspaceManager.c"
	}
#line 132 "../src/WorkspaceManager.vala"
	if (_tmp6_) {
#line 578 "WorkspaceManager.c"
		MetaScreen* _tmp14_;
#line 135 "../src/WorkspaceManager.vala"
		_tmp14_ = screen;
#line 135 "../src/WorkspaceManager.vala"
		_tmp5_ = meta_workspace_index (workspace) == (meta_screen_get_n_workspaces (_tmp14_) - 1);
#line 584 "WorkspaceManager.c"
	} else {
#line 132 "../src/WorkspaceManager.vala"
		_tmp5_ = FALSE;
#line 588 "WorkspaceManager.c"
	}
#line 132 "../src/WorkspaceManager.vala"
	if (_tmp5_) {
#line 136 "../src/WorkspaceManager.vala"
		gala_workspace_manager_append_workspace (self);
#line 594 "WorkspaceManager.c"
	}
}

static void
gala_workspace_manager_window_removed (GalaWorkspaceManager* self,
                                       MetaWorkspace* workspace,
                                       MetaWindow* window)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	MetaScreen* screen = NULL;
	MetaScreen* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	MetaWindowType _tmp7_;
	MetaWindowType _tmp8_;
	gint index = 0;
	MetaScreen* _tmp13_;
	GList* _tmp14_;
	gboolean is_active_workspace = FALSE;
	MetaScreen* _tmp15_;
	MetaWorkspace* _tmp16_;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
#line 139 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 139 "../src/WorkspaceManager.vala"
	g_return_if_fail (window != NULL);
#line 141 "../src/WorkspaceManager.vala"
	if (workspace == NULL) {
#line 141 "../src/WorkspaceManager.vala"
		_tmp1_ = TRUE;
#line 629 "WorkspaceManager.c"
	} else {
#line 141 "../src/WorkspaceManager.vala"
		_tmp1_ = !meta_prefs_get_dynamic_workspaces ();
#line 633 "WorkspaceManager.c"
	}
#line 141 "../src/WorkspaceManager.vala"
	if (_tmp1_) {
#line 141 "../src/WorkspaceManager.vala"
		_tmp0_ = TRUE;
#line 639 "WorkspaceManager.c"
	} else {
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 141 "../src/WorkspaceManager.vala"
		g_object_get (window, "on-all-workspaces", &_tmp2_, NULL);
#line 141 "../src/WorkspaceManager.vala"
		_tmp3_ = _tmp2_;
#line 141 "../src/WorkspaceManager.vala"
		_tmp0_ = _tmp3_;
#line 649 "WorkspaceManager.c"
	}
#line 141 "../src/WorkspaceManager.vala"
	if (_tmp0_) {
#line 142 "../src/WorkspaceManager.vala"
		return;
#line 655 "WorkspaceManager.c"
	}
#line 144 "../src/WorkspaceManager.vala"
	_tmp4_ = meta_workspace_get_screen (workspace);
#line 144 "../src/WorkspaceManager.vala"
	screen = _tmp4_;
#line 146 "../src/WorkspaceManager.vala"
	_tmp7_ = meta_window_get_window_type (window);
#line 146 "../src/WorkspaceManager.vala"
	_tmp8_ = _tmp7_;
#line 146 "../src/WorkspaceManager.vala"
	if (_tmp8_ != META_WINDOW_NORMAL) {
#line 667 "WorkspaceManager.c"
		MetaWindowType _tmp9_;
		MetaWindowType _tmp10_;
#line 147 "../src/WorkspaceManager.vala"
		_tmp9_ = meta_window_get_window_type (window);
#line 147 "../src/WorkspaceManager.vala"
		_tmp10_ = _tmp9_;
#line 147 "../src/WorkspaceManager.vala"
		_tmp6_ = _tmp10_ != META_WINDOW_DIALOG;
#line 676 "WorkspaceManager.c"
	} else {
#line 146 "../src/WorkspaceManager.vala"
		_tmp6_ = FALSE;
#line 680 "WorkspaceManager.c"
	}
#line 146 "../src/WorkspaceManager.vala"
	if (_tmp6_) {
#line 684 "WorkspaceManager.c"
		MetaWindowType _tmp11_;
		MetaWindowType _tmp12_;
#line 148 "../src/WorkspaceManager.vala"
		_tmp11_ = meta_window_get_window_type (window);
#line 148 "../src/WorkspaceManager.vala"
		_tmp12_ = _tmp11_;
#line 148 "../src/WorkspaceManager.vala"
		_tmp5_ = _tmp12_ != META_WINDOW_MODAL_DIALOG;
#line 693 "WorkspaceManager.c"
	} else {
#line 146 "../src/WorkspaceManager.vala"
		_tmp5_ = FALSE;
#line 697 "WorkspaceManager.c"
	}
#line 146 "../src/WorkspaceManager.vala"
	if (_tmp5_) {
#line 149 "../src/WorkspaceManager.vala"
		return;
#line 703 "WorkspaceManager.c"
	}
#line 151 "../src/WorkspaceManager.vala"
	_tmp13_ = screen;
#line 151 "../src/WorkspaceManager.vala"
	_tmp14_ = meta_screen_get_workspaces (_tmp13_);
#line 151 "../src/WorkspaceManager.vala"
	index = g_list_index (_tmp14_, workspace);
#line 153 "../src/WorkspaceManager.vala"
	if (index < 0) {
#line 154 "../src/WorkspaceManager.vala"
		return;
#line 715 "WorkspaceManager.c"
	}
#line 156 "../src/WorkspaceManager.vala"
	_tmp15_ = screen;
#line 156 "../src/WorkspaceManager.vala"
	_tmp16_ = meta_screen_get_active_workspace (_tmp15_);
#line 156 "../src/WorkspaceManager.vala"
	is_active_workspace = workspace == _tmp16_;
#line 160 "../src/WorkspaceManager.vala"
	if (!is_active_workspace) {
#line 160 "../src/WorkspaceManager.vala"
		_tmp20_ = TRUE;
#line 727 "WorkspaceManager.c"
	} else {
		GalaWindowManager* _tmp21_;
#line 160 "../src/WorkspaceManager.vala"
		_tmp21_ = self->priv->_wm;
#line 160 "../src/WorkspaceManager.vala"
		_tmp20_ = gala_window_manager_is_modal (_tmp21_);
#line 734 "WorkspaceManager.c"
	}
#line 160 "../src/WorkspaceManager.vala"
	if (_tmp20_) {
#line 161 "../src/WorkspaceManager.vala"
		_tmp19_ = self->priv->remove_freeze_count < 1;
#line 740 "WorkspaceManager.c"
	} else {
#line 160 "../src/WorkspaceManager.vala"
		_tmp19_ = FALSE;
#line 744 "WorkspaceManager.c"
	}
#line 160 "../src/WorkspaceManager.vala"
	if (_tmp19_) {
#line 162 "../src/WorkspaceManager.vala"
		_tmp18_ = gala_utils_get_n_windows (workspace) < ((guint) 1);
#line 750 "WorkspaceManager.c"
	} else {
#line 160 "../src/WorkspaceManager.vala"
		_tmp18_ = FALSE;
#line 754 "WorkspaceManager.c"
	}
#line 160 "../src/WorkspaceManager.vala"
	if (_tmp18_) {
#line 758 "WorkspaceManager.c"
		MetaScreen* _tmp22_;
#line 163 "../src/WorkspaceManager.vala"
		_tmp22_ = screen;
#line 163 "../src/WorkspaceManager.vala"
		_tmp17_ = index != (meta_screen_get_n_workspaces (_tmp22_) - 1);
#line 764 "WorkspaceManager.c"
	} else {
#line 160 "../src/WorkspaceManager.vala"
		_tmp17_ = FALSE;
#line 768 "WorkspaceManager.c"
	}
#line 160 "../src/WorkspaceManager.vala"
	if (_tmp17_) {
#line 164 "../src/WorkspaceManager.vala"
		gala_workspace_manager_remove_workspace (self, workspace);
#line 774 "WorkspaceManager.c"
	}
}

static void
gala_workspace_manager_window_entered_monitor (GalaWorkspaceManager* self,
                                               MetaScreen* screen,
                                               gint monitor,
                                               MetaWindow* window)
{
	gboolean _tmp0_ = FALSE;
#line 168 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 168 "../src/WorkspaceManager.vala"
	g_return_if_fail (screen != NULL);
#line 168 "../src/WorkspaceManager.vala"
	g_return_if_fail (window != NULL);
#line 170 "../src/WorkspaceManager.vala"
	if (gala_internal_utils_workspaces_only_on_primary ()) {
#line 171 "../src/WorkspaceManager.vala"
		_tmp0_ = monitor == meta_screen_get_primary_monitor (screen);
#line 795 "WorkspaceManager.c"
	} else {
#line 170 "../src/WorkspaceManager.vala"
		_tmp0_ = FALSE;
#line 799 "WorkspaceManager.c"
	}
#line 170 "../src/WorkspaceManager.vala"
	if (_tmp0_) {
#line 803 "WorkspaceManager.c"
		MetaWorkspace* _tmp1_;
#line 172 "../src/WorkspaceManager.vala"
		_tmp1_ = meta_window_get_workspace (window);
#line 172 "../src/WorkspaceManager.vala"
		gala_workspace_manager_window_added (self, _tmp1_, window);
#line 809 "WorkspaceManager.c"
	}
}

static void
gala_workspace_manager_window_left_monitor (GalaWorkspaceManager* self,
                                            MetaScreen* screen,
                                            gint monitor,
                                            MetaWindow* window)
{
	gboolean _tmp0_ = FALSE;
#line 175 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 175 "../src/WorkspaceManager.vala"
	g_return_if_fail (screen != NULL);
#line 175 "../src/WorkspaceManager.vala"
	g_return_if_fail (window != NULL);
#line 177 "../src/WorkspaceManager.vala"
	if (gala_internal_utils_workspaces_only_on_primary ()) {
#line 178 "../src/WorkspaceManager.vala"
		_tmp0_ = monitor == meta_screen_get_primary_monitor (screen);
#line 830 "WorkspaceManager.c"
	} else {
#line 177 "../src/WorkspaceManager.vala"
		_tmp0_ = FALSE;
#line 834 "WorkspaceManager.c"
	}
#line 177 "../src/WorkspaceManager.vala"
	if (_tmp0_) {
#line 838 "WorkspaceManager.c"
		MetaWorkspace* _tmp1_;
#line 179 "../src/WorkspaceManager.vala"
		_tmp1_ = meta_window_get_workspace (window);
#line 179 "../src/WorkspaceManager.vala"
		gala_workspace_manager_window_removed (self, _tmp1_, window);
#line 844 "WorkspaceManager.c"
	}
}

static void
gala_workspace_manager_prefs_listener (GalaWorkspaceManager* self,
                                       MetaPreference pref)
{
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 182 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 184 "../src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 184 "../src/WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 184 "../src/WorkspaceManager.vala"
	screen = _tmp1_;
#line 186 "../src/WorkspaceManager.vala"
	if (pref == META_PREF_DYNAMIC_WORKSPACES) {
#line 186 "../src/WorkspaceManager.vala"
		_tmp2_ = meta_prefs_get_dynamic_workspaces ();
#line 868 "WorkspaceManager.c"
	} else {
#line 186 "../src/WorkspaceManager.vala"
		_tmp2_ = FALSE;
#line 872 "WorkspaceManager.c"
	}
#line 186 "../src/WorkspaceManager.vala"
	if (_tmp2_) {
#line 876 "WorkspaceManager.c"
		MetaScreen* _tmp3_;
		MetaScreen* _tmp4_;
		MetaWorkspace* _tmp5_;
#line 188 "../src/WorkspaceManager.vala"
		_tmp3_ = screen;
#line 188 "../src/WorkspaceManager.vala"
		_tmp4_ = screen;
#line 188 "../src/WorkspaceManager.vala"
		_tmp5_ = meta_screen_get_workspace_by_index (_tmp3_, meta_screen_get_n_workspaces (_tmp4_) - 1);
#line 188 "../src/WorkspaceManager.vala"
		if (gala_utils_get_n_windows (_tmp5_) > ((guint) 0)) {
#line 189 "../src/WorkspaceManager.vala"
			gala_workspace_manager_append_workspace (self);
#line 890 "WorkspaceManager.c"
		}
	}
}

static void
gala_workspace_manager_append_workspace (GalaWorkspaceManager* self)
{
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaDisplay* _tmp2_;
#line 193 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 195 "../src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 195 "../src/WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 195 "../src/WorkspaceManager.vala"
	screen = _tmp1_;
#line 197 "../src/WorkspaceManager.vala"
	_tmp2_ = meta_screen_get_display (screen);
#line 197 "../src/WorkspaceManager.vala"
	meta_screen_append_new_workspace (screen, FALSE, meta_display_get_current_time (_tmp2_));
#line 914 "WorkspaceManager.c"
}

/**
 * Make sure we switch to a different workspace and remove the given one
 *
 * @param workspace The workspace to remove
 */
static void
gala_workspace_manager_remove_workspace (GalaWorkspaceManager* self,
                                         MetaWorkspace* workspace)
{
	MetaScreen* screen = NULL;
	MetaScreen* _tmp0_;
	guint32 time = 0U;
	MetaScreen* _tmp1_;
	MetaDisplay* _tmp2_;
	MetaScreen* _tmp3_;
	MetaWorkspace* _tmp4_;
	GeeLinkedList* _tmp14_;
	guint _tmp15_;
	guint _tmp16_;
	GeeLinkedList* _tmp17_;
	MetaScreen* _tmp18_;
#line 205 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 205 "../src/WorkspaceManager.vala"
	g_return_if_fail (workspace != NULL);
#line 207 "../src/WorkspaceManager.vala"
	_tmp0_ = meta_workspace_get_screen (workspace);
#line 207 "../src/WorkspaceManager.vala"
	screen = _tmp0_;
#line 209 "../src/WorkspaceManager.vala"
	_tmp1_ = screen;
#line 209 "../src/WorkspaceManager.vala"
	_tmp2_ = meta_screen_get_display (_tmp1_);
#line 209 "../src/WorkspaceManager.vala"
	time = meta_display_get_current_time (_tmp2_);
#line 211 "../src/WorkspaceManager.vala"
	_tmp3_ = screen;
#line 211 "../src/WorkspaceManager.vala"
	_tmp4_ = meta_screen_get_active_workspace (_tmp3_);
#line 211 "../src/WorkspaceManager.vala"
	if (workspace == _tmp4_) {
#line 958 "WorkspaceManager.c"
		MetaWorkspace* next = NULL;
		MetaWorkspace* _tmp5_;
		MetaWorkspace* _tmp6_;
		gboolean _tmp7_ = FALSE;
		MetaWorkspace* _tmp8_;
		MetaWorkspace* _tmp12_;
#line 212 "../src/WorkspaceManager.vala"
		next = NULL;
#line 214 "../src/WorkspaceManager.vala"
		_tmp5_ = meta_workspace_get_neighbor (workspace, META_MOTION_LEFT);
#line 214 "../src/WorkspaceManager.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 214 "../src/WorkspaceManager.vala"
		_g_object_unref0 (next);
#line 214 "../src/WorkspaceManager.vala"
		next = _tmp6_;
#line 216 "../src/WorkspaceManager.vala"
		_tmp8_ = next;
#line 216 "../src/WorkspaceManager.vala"
		if (_tmp8_ == workspace) {
#line 216 "../src/WorkspaceManager.vala"
			_tmp7_ = TRUE;
#line 981 "WorkspaceManager.c"
		} else {
			MetaWorkspace* _tmp9_;
#line 216 "../src/WorkspaceManager.vala"
			_tmp9_ = next;
#line 216 "../src/WorkspaceManager.vala"
			_tmp7_ = _tmp9_ == NULL;
#line 988 "WorkspaceManager.c"
		}
#line 216 "../src/WorkspaceManager.vala"
		if (_tmp7_) {
#line 992 "WorkspaceManager.c"
			MetaWorkspace* _tmp10_;
			MetaWorkspace* _tmp11_;
#line 217 "../src/WorkspaceManager.vala"
			_tmp10_ = meta_workspace_get_neighbor (workspace, META_MOTION_RIGHT);
#line 217 "../src/WorkspaceManager.vala"
			_tmp11_ = _g_object_ref0 (_tmp10_);
#line 217 "../src/WorkspaceManager.vala"
			_g_object_unref0 (next);
#line 217 "../src/WorkspaceManager.vala"
			next = _tmp11_;
#line 1003 "WorkspaceManager.c"
		}
#line 219 "../src/WorkspaceManager.vala"
		_tmp12_ = next;
#line 219 "../src/WorkspaceManager.vala"
		if (_tmp12_ != NULL) {
#line 1009 "WorkspaceManager.c"
			MetaWorkspace* _tmp13_;
#line 220 "../src/WorkspaceManager.vala"
			_tmp13_ = next;
#line 220 "../src/WorkspaceManager.vala"
			meta_workspace_activate (_tmp13_, time);
#line 1015 "WorkspaceManager.c"
		}
#line 211 "../src/WorkspaceManager.vala"
		_g_object_unref0 (next);
#line 1019 "WorkspaceManager.c"
	}
#line 224 "../src/WorkspaceManager.vala"
	_tmp14_ = self->priv->workspaces_marked_removed;
#line 224 "../src/WorkspaceManager.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp14_, workspace)) {
#line 225 "../src/WorkspaceManager.vala"
		return;
#line 1027 "WorkspaceManager.c"
	}
#line 228 "../src/WorkspaceManager.vala"
	g_signal_parse_name ("window-added", meta_workspace_get_type (), &_tmp15_, NULL, FALSE);
#line 228 "../src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (workspace, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp15_, 0, NULL, (GCallback) _gala_workspace_manager_window_added_meta_workspace_window_added, self);
#line 229 "../src/WorkspaceManager.vala"
	g_signal_parse_name ("window-removed", meta_workspace_get_type (), &_tmp16_, NULL, FALSE);
#line 229 "../src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (workspace, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp16_, 0, NULL, (GCallback) _gala_workspace_manager_window_removed_meta_workspace_window_removed, self);
#line 231 "../src/WorkspaceManager.vala"
	_tmp17_ = self->priv->workspaces_marked_removed;
#line 231 "../src/WorkspaceManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, workspace);
#line 233 "../src/WorkspaceManager.vala"
	_tmp18_ = screen;
#line 233 "../src/WorkspaceManager.vala"
	meta_screen_remove_workspace (_tmp18_, workspace, time);
#line 1045 "WorkspaceManager.c"
}

/**
 * Temporarily disables removing workspaces when they are empty
 */
void
gala_workspace_manager_freeze_remove (GalaWorkspaceManager* self)
{
	gint _tmp0_;
#line 239 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 241 "../src/WorkspaceManager.vala"
	_tmp0_ = self->priv->remove_freeze_count;
#line 241 "../src/WorkspaceManager.vala"
	self->priv->remove_freeze_count = _tmp0_ + 1;
#line 1061 "WorkspaceManager.c"
}

/**
 * Undo the effect of freeze_remove()
 */
void
gala_workspace_manager_thaw_remove (GalaWorkspaceManager* self)
{
	gint _tmp0_;
#line 247 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 249 "../src/WorkspaceManager.vala"
	_tmp0_ = self->priv->remove_freeze_count;
#line 249 "../src/WorkspaceManager.vala"
	self->priv->remove_freeze_count = _tmp0_ - 1;
#line 251 "../src/WorkspaceManager.vala"
	_vala_assert (self->priv->remove_freeze_count >= 0, "remove_freeze_count >= 0");
#line 1079 "WorkspaceManager.c"
}

/**
 * If workspaces are dynamic, checks if there are empty workspaces that should
 * be removed. Particularily useful in conjunction with freeze/thaw_remove to
 * cleanup after an operation that required stable workspace/window indices
 */
void
gala_workspace_manager_cleanup (GalaWorkspaceManager* self)
{
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaScreen* _tmp2_;
	gint last_index = 0;
	MetaScreen* _tmp3_;
	MetaScreen* _tmp4_;
	GList* _tmp5_;
#line 259 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 261 "../src/WorkspaceManager.vala"
	if (!meta_prefs_get_dynamic_workspaces ()) {
#line 262 "../src/WorkspaceManager.vala"
		return;
#line 1104 "WorkspaceManager.c"
	}
#line 264 "../src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 264 "../src/WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 264 "../src/WorkspaceManager.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 264 "../src/WorkspaceManager.vala"
	screen = _tmp2_;
#line 265 "../src/WorkspaceManager.vala"
	_tmp3_ = screen;
#line 265 "../src/WorkspaceManager.vala"
	last_index = meta_screen_get_n_workspaces (_tmp3_) - 1;
#line 267 "../src/WorkspaceManager.vala"
	_tmp4_ = screen;
#line 267 "../src/WorkspaceManager.vala"
	_tmp5_ = meta_screen_get_workspaces (_tmp4_);
#line 1122 "WorkspaceManager.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 267 "../src/WorkspaceManager.vala"
		workspace_collection = _tmp5_;
#line 267 "../src/WorkspaceManager.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 1130 "WorkspaceManager.c"
			MetaWorkspace* _tmp6_;
			MetaWorkspace* workspace = NULL;
#line 267 "../src/WorkspaceManager.vala"
			_tmp6_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 267 "../src/WorkspaceManager.vala"
			workspace = _tmp6_;
#line 1137 "WorkspaceManager.c"
			{
				gboolean _tmp7_ = FALSE;
				MetaWorkspace* _tmp8_;
#line 268 "../src/WorkspaceManager.vala"
				_tmp8_ = workspace;
#line 268 "../src/WorkspaceManager.vala"
				if (gala_utils_get_n_windows (_tmp8_) < ((guint) 1)) {
#line 1145 "WorkspaceManager.c"
					MetaWorkspace* _tmp9_;
#line 269 "../src/WorkspaceManager.vala"
					_tmp9_ = workspace;
#line 269 "../src/WorkspaceManager.vala"
					_tmp7_ = meta_workspace_index (_tmp9_) != last_index;
#line 1151 "WorkspaceManager.c"
				} else {
#line 268 "../src/WorkspaceManager.vala"
					_tmp7_ = FALSE;
#line 1155 "WorkspaceManager.c"
				}
#line 268 "../src/WorkspaceManager.vala"
				if (_tmp7_) {
#line 1159 "WorkspaceManager.c"
					MetaWorkspace* _tmp10_;
#line 270 "../src/WorkspaceManager.vala"
					_tmp10_ = workspace;
#line 270 "../src/WorkspaceManager.vala"
					gala_workspace_manager_remove_workspace (self, _tmp10_);
#line 1165 "WorkspaceManager.c"
				}
#line 267 "../src/WorkspaceManager.vala"
				_g_object_unref0 (workspace);
#line 1169 "WorkspaceManager.c"
			}
		}
	}
#line 259 "../src/WorkspaceManager.vala"
	_g_object_unref0 (screen);
#line 1175 "WorkspaceManager.c"
}

GalaWindowManager*
gala_workspace_manager_get_wm (GalaWorkspaceManager* self)
{
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
#line 38 "../src/WorkspaceManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 38 "../src/WorkspaceManager.vala"
	result = _tmp0_;
#line 38 "../src/WorkspaceManager.vala"
	return result;
#line 1191 "WorkspaceManager.c"
}

static void
gala_workspace_manager_set_wm (GalaWorkspaceManager* self,
                               GalaWindowManager* value)
{
#line 38 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/WorkspaceManager.vala"
	if (gala_workspace_manager_get_wm (self) != value) {
#line 1202 "WorkspaceManager.c"
		GalaWindowManager* _tmp0_;
#line 38 "../src/WorkspaceManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 38 "../src/WorkspaceManager.vala"
		_g_object_unref0 (self->priv->_wm);
#line 38 "../src/WorkspaceManager.vala"
		self->priv->_wm = _tmp0_;
#line 38 "../src/WorkspaceManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_WM_PROPERTY]);
#line 1212 "WorkspaceManager.c"
	}
}

static GObject *
gala_workspace_manager_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWorkspaceManager * self;
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	GeeLinkedList* _tmp2_;
	MetaScreen* _tmp8_;
	MetaScreen* _tmp9_;
	MetaScreen* _tmp10_;
	MetaScreen* _tmp11_;
	MetaScreen* _tmp12_;
	gboolean _tmp13_ = FALSE;
#line 48 "../src/WorkspaceManager.vala"
	parent_class = G_OBJECT_CLASS (gala_workspace_manager_parent_class);
#line 48 "../src/WorkspaceManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 48 "../src/WorkspaceManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 50 "../src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 50 "../src/WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 50 "../src/WorkspaceManager.vala"
	screen = _tmp1_;
#line 52 "../src/WorkspaceManager.vala"
	_tmp2_ = gee_linked_list_new (meta_workspace_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 52 "../src/WorkspaceManager.vala"
	_g_object_unref0 (self->priv->workspaces_marked_removed);
#line 52 "../src/WorkspaceManager.vala"
	self->priv->workspaces_marked_removed = _tmp2_;
#line 54 "../src/WorkspaceManager.vala"
	if (meta_prefs_get_dynamic_workspaces ()) {
#line 1254 "WorkspaceManager.c"
		MetaScreen* _tmp3_;
#line 55 "../src/WorkspaceManager.vala"
		_tmp3_ = screen;
#line 55 "../src/WorkspaceManager.vala"
		meta_screen_override_workspace_layout (_tmp3_, META_SCREEN_TOPLEFT, FALSE, 1, -1);
#line 1260 "WorkspaceManager.c"
	}
	{
		gint i = 0;
#line 57 "../src/WorkspaceManager.vala"
		i = 0;
#line 1266 "WorkspaceManager.c"
		{
			gboolean _tmp4_ = FALSE;
#line 57 "../src/WorkspaceManager.vala"
			_tmp4_ = TRUE;
#line 57 "../src/WorkspaceManager.vala"
			while (TRUE) {
#line 1273 "WorkspaceManager.c"
				MetaScreen* _tmp6_;
				MetaScreen* _tmp7_;
#line 57 "../src/WorkspaceManager.vala"
				if (!_tmp4_) {
#line 1278 "WorkspaceManager.c"
					gint _tmp5_;
#line 57 "../src/WorkspaceManager.vala"
					_tmp5_ = i;
#line 57 "../src/WorkspaceManager.vala"
					i = _tmp5_ + 1;
#line 1284 "WorkspaceManager.c"
				}
#line 57 "../src/WorkspaceManager.vala"
				_tmp4_ = FALSE;
#line 57 "../src/WorkspaceManager.vala"
				_tmp6_ = screen;
#line 57 "../src/WorkspaceManager.vala"
				if (!(i < meta_screen_get_n_workspaces (_tmp6_))) {
#line 57 "../src/WorkspaceManager.vala"
					break;
#line 1294 "WorkspaceManager.c"
				}
#line 58 "../src/WorkspaceManager.vala"
				_tmp7_ = screen;
#line 58 "../src/WorkspaceManager.vala"
				gala_workspace_manager_workspace_added (self, _tmp7_, i);
#line 1300 "WorkspaceManager.c"
			}
		}
	}
#line 60 "../src/WorkspaceManager.vala"
	meta_prefs_add_listener (_gala_workspace_manager_prefs_listener_meta_prefs_changed_func, self);
#line 62 "../src/WorkspaceManager.vala"
	_tmp8_ = screen;
#line 62 "../src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp8_, "workspace-switched", (GCallback) _gala_workspace_manager_workspace_switched_meta_screen_workspace_switched, self, G_CONNECT_AFTER);
#line 63 "../src/WorkspaceManager.vala"
	_tmp9_ = screen;
#line 63 "../src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp9_, "workspace-added", (GCallback) _gala_workspace_manager_workspace_added_meta_screen_workspace_added, self, 0);
#line 64 "../src/WorkspaceManager.vala"
	_tmp10_ = screen;
#line 64 "../src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp10_, "workspace-removed", (GCallback) _gala_workspace_manager_workspace_removed_meta_screen_workspace_removed, self, G_CONNECT_AFTER);
#line 65 "../src/WorkspaceManager.vala"
	_tmp11_ = screen;
#line 65 "../src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp11_, "window-entered-monitor", (GCallback) _gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor, self, 0);
#line 66 "../src/WorkspaceManager.vala"
	_tmp12_ = screen;
#line 66 "../src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp12_, "window-left-monitor", (GCallback) _gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor, self, 0);
#line 69 "../src/WorkspaceManager.vala"
	if (meta_prefs_get_dynamic_workspaces ()) {
#line 1328 "WorkspaceManager.c"
		MetaScreen* _tmp14_;
		MetaScreen* _tmp15_;
		MetaWorkspace* _tmp16_;
#line 70 "../src/WorkspaceManager.vala"
		_tmp14_ = screen;
#line 70 "../src/WorkspaceManager.vala"
		_tmp15_ = screen;
#line 70 "../src/WorkspaceManager.vala"
		_tmp16_ = meta_screen_get_workspace_by_index (_tmp14_, meta_screen_get_n_workspaces (_tmp15_) - 1);
#line 70 "../src/WorkspaceManager.vala"
		_tmp13_ = gala_utils_get_n_windows (_tmp16_) > ((guint) 0);
#line 1340 "WorkspaceManager.c"
	} else {
#line 69 "../src/WorkspaceManager.vala"
		_tmp13_ = FALSE;
#line 1344 "WorkspaceManager.c"
	}
#line 69 "../src/WorkspaceManager.vala"
	if (_tmp13_) {
#line 71 "../src/WorkspaceManager.vala"
		gala_workspace_manager_append_workspace (self);
#line 1350 "WorkspaceManager.c"
	}
#line 74 "../src/WorkspaceManager.vala"
	gala_workspace_manager_cleanup (self);
#line 48 "../src/WorkspaceManager.vala"
	return obj;
#line 1356 "WorkspaceManager.c"
}

static void
gala_workspace_manager_class_init (GalaWorkspaceManagerClass * klass,
                                   gpointer klass_data)
{
#line 22 "../src/WorkspaceManager.vala"
	gala_workspace_manager_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/WorkspaceManager.vala"
	g_type_class_adjust_private_offset (klass, &GalaWorkspaceManager_private_offset);
#line 22 "../src/WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_workspace_manager_get_property;
#line 22 "../src/WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_workspace_manager_set_property;
#line 22 "../src/WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_workspace_manager_constructor;
#line 22 "../src/WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_workspace_manager_finalize;
#line 22 "../src/WorkspaceManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WORKSPACE_MANAGER_WM_PROPERTY, gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1377 "WorkspaceManager.c"
}

static void
gala_workspace_manager_instance_init (GalaWorkspaceManager * self,
                                      gpointer klass)
{
#line 22 "../src/WorkspaceManager.vala"
	self->priv = gala_workspace_manager_get_instance_private (self);
#line 41 "../src/WorkspaceManager.vala"
	self->priv->remove_freeze_count = 0;
#line 1388 "WorkspaceManager.c"
}

static void
gala_workspace_manager_finalize (GObject * obj)
{
	GalaWorkspaceManager * self;
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaScreen* _tmp2_;
	guint _tmp3_;
	MetaScreen* _tmp4_;
	guint _tmp5_;
	MetaScreen* _tmp6_;
	guint _tmp7_;
	MetaScreen* _tmp8_;
	guint _tmp9_;
	MetaScreen* _tmp10_;
	guint _tmp11_;
#line 22 "../src/WorkspaceManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 79 "../src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 79 "../src/WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 79 "../src/WorkspaceManager.vala"
	screen = _tmp1_;
#line 81 "../src/WorkspaceManager.vala"
	meta_prefs_remove_listener (_gala_workspace_manager_prefs_listener_meta_prefs_changed_func, self);
#line 83 "../src/WorkspaceManager.vala"
	_tmp2_ = screen;
#line 83 "../src/WorkspaceManager.vala"
	g_signal_parse_name ("workspace-added", meta_screen_get_type (), &_tmp3_, NULL, FALSE);
#line 83 "../src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _gala_workspace_manager_workspace_added_meta_screen_workspace_added, self);
#line 84 "../src/WorkspaceManager.vala"
	_tmp4_ = screen;
#line 84 "../src/WorkspaceManager.vala"
	g_signal_parse_name ("workspace-switched", meta_screen_get_type (), &_tmp5_, NULL, FALSE);
#line 84 "../src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _gala_workspace_manager_workspace_switched_meta_screen_workspace_switched, self);
#line 85 "../src/WorkspaceManager.vala"
	_tmp6_ = screen;
#line 85 "../src/WorkspaceManager.vala"
	g_signal_parse_name ("workspace-removed", meta_screen_get_type (), &_tmp7_, NULL, FALSE);
#line 85 "../src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _gala_workspace_manager_workspace_removed_meta_screen_workspace_removed, self);
#line 86 "../src/WorkspaceManager.vala"
	_tmp8_ = screen;
#line 86 "../src/WorkspaceManager.vala"
	g_signal_parse_name ("window-entered-monitor", meta_screen_get_type (), &_tmp9_, NULL, FALSE);
#line 86 "../src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor, self);
#line 87 "../src/WorkspaceManager.vala"
	_tmp10_ = screen;
#line 87 "../src/WorkspaceManager.vala"
	g_signal_parse_name ("window-left-monitor", meta_screen_get_type (), &_tmp11_, NULL, FALSE);
#line 87 "../src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor, self);
#line 38 "../src/WorkspaceManager.vala"
	_g_object_unref0 (self->priv->_wm);
#line 40 "../src/WorkspaceManager.vala"
	_g_object_unref0 (self->priv->workspaces_marked_removed);
#line 22 "../src/WorkspaceManager.vala"
	G_OBJECT_CLASS (gala_workspace_manager_parent_class)->finalize (obj);
#line 1454 "WorkspaceManager.c"
}

GType
gala_workspace_manager_get_type (void)
{
	static volatile gsize gala_workspace_manager_type_id__volatile = 0;
	if (g_once_init_enter (&gala_workspace_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaWorkspaceManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_workspace_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWorkspaceManager), 0, (GInstanceInitFunc) gala_workspace_manager_instance_init, NULL };
		GType gala_workspace_manager_type_id;
		gala_workspace_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaWorkspaceManager", &g_define_type_info, 0);
		GalaWorkspaceManager_private_offset = g_type_add_instance_private (gala_workspace_manager_type_id, sizeof (GalaWorkspaceManagerPrivate));
		g_once_init_leave (&gala_workspace_manager_type_id__volatile, gala_workspace_manager_type_id);
	}
	return gala_workspace_manager_type_id__volatile;
}

static void
_vala_gala_workspace_manager_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	GalaWorkspaceManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 22 "../src/WorkspaceManager.vala"
	switch (property_id) {
#line 22 "../src/WorkspaceManager.vala"
		case GALA_WORKSPACE_MANAGER_WM_PROPERTY:
#line 22 "../src/WorkspaceManager.vala"
		g_value_set_object (value, gala_workspace_manager_get_wm (self));
#line 22 "../src/WorkspaceManager.vala"
		break;
#line 1487 "WorkspaceManager.c"
		default:
#line 22 "../src/WorkspaceManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/WorkspaceManager.vala"
		break;
#line 1493 "WorkspaceManager.c"
	}
}

static void
_vala_gala_workspace_manager_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	GalaWorkspaceManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 22 "../src/WorkspaceManager.vala"
	switch (property_id) {
#line 22 "../src/WorkspaceManager.vala"
		case GALA_WORKSPACE_MANAGER_WM_PROPERTY:
#line 22 "../src/WorkspaceManager.vala"
		gala_workspace_manager_set_wm (self, g_value_get_object (value));
#line 22 "../src/WorkspaceManager.vala"
		break;
#line 1513 "WorkspaceManager.c"
		default:
#line 22 "../src/WorkspaceManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/WorkspaceManager.vala"
		break;
#line 1519 "WorkspaceManager.c"
	}
}

